C............................................................Jan. 2021
C Run polyfit between UT & UT-1 to fill missed foF2 data
C output : p1,p2,p3,rms (polynomial 2-order
C a b = polynomial 1st order
C
C       "MEDIAN" 
      program cntpoldy1
C
      DIMENSION x24(24),y24(24),xmon(31,0:23)
      character*2 ayr,amn,ady
	character*45 infile,outfile
c
C
   97 format(1X,A2)
C
Crem	st='mo'			  !Moscow
	infile='mo202011f.txt'
	outfile='cntpoldy1'
C
  111	FORMAT(A120)
  112 FORMAT(3A2,24(1X,F4.1))
  107	FORMAT(24(F3.1,A2))
  117	FORMAT(24(I3,2X))
  127	FORMAT(24(I3,A2))
  137	FORMAT(24(A5))
c Current year	
	OPEN(12,file=infile,action='READ')
C
	OPEN(13,file=outfile)
C
C
C
         ndmn=30
	    do kk=1,30		   !+++++++++++++++++++++++++++++++++++++++++
	read(12,112,end=108) AYR,AMN,ADY,(xmon(kk,k),k=0,23)
	enddo
  108	close(unit=12)
C
	DO idy=1,29
	call blet2(idy,ADY)
C 
       DO mm=0,23					 !.............
	 x24(mm+1)=xmon(idy,mm)
	y24(mm+1)=xmon(idy+1,mm)
	 ENDDO						  !..............
C
	call subpoly1p(x24,y24,a1,b1,rmse)
	write(*,*) ADY,a1,b1,rmse
	write(13,*) ADY,a1,b1,rmse
       ENDDO
C
  410 CONTINUE
  	close(unit=13)
C
C
   33	continue
      write(*,*) infile,outfile
c-	goto 1
   34   pause ' ' 
      STOP
       END

C++
c----------------------------------------------------------------------
      subroutine subpoly3p(x,y,p1,p2,p3,rmse)
	dimension x(24),y(24) 
	nut=24  ! diurnal UT set
C  
	s0=24.
	s1=0.
	s2=0.
	s3=0.
	s4=0.
	syx2=0.
	syx=0.
	sy=0.
      DO N=1,nut
	x1=x(N)
	x2=x1*x1
	x3=x1*x2
	x4=x2*x2
	y1=y(N)
	yx=y1*x1
	yx2=y1*x2
	s1=s1+x1
	s2=s2+x2
	s3=s3+x3
	s4=s4+x4
	syx2=syx2+yx2
	syx=syx+yx
	sy=sy+y1
      ENDDO 
C
      d1=(s0*s3-s1*s2)
      c1=(s0*s4-s2*s2)/d1
      c2=(s0*syx2-sy*s2)/d1
	d2=(s0*s2-s1*s1)
      c3=(s0*s3-s1*s2)/d2
      c4=(s0*syx-sy*s1)/d2

C
C p1=a; p2=b; p3=c
C
C polyfit2 coefficients
	p1=(c2-c4)/(c1-c3)
	p2=c2-p1*c1
	p3=(sy-p1*s2-p2*s1)/s0
C RMSE
      sum=0.
	DO N=1,nut
	del=y(N)-(x(N)*(p1*x(N)+p2)+p3)
	sum=sum+del**2
	ENDDO
	rmse=sqrt(sum/nut)
C
	RETURN
	END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c----------------------------------------------------------------------
      subroutine subpoly1p(x,y,a,b,rmse)
	dimension x(24),y(24) 
	nut=24  ! diurnal UT set
C  
	s0=24.
	sx=0.
      sx2=0.
	sy=0.
	sxy=0.
      DO N=1,nut
	x1=x(N)
	x2=x1*x1
	y1=y(N)
	xy=y1*x1
	sx=sx+x1
	sy=sy+y1
	sx2=sx2+x2
	sxy=sxy+xy
      ENDDO 
C
      sx=sx/s0
      sy=sy/s0
	sx2=sx2/s0
      sxy=sxy/s0
	a=(sxy-sx*sy)/(sx2-sx*sx)
	b=sy-a*sx
C
C p1=a; p2=b; p3=c
C
C RMSE
      sum=0.
	DO N=1,nut
	del=y(N)-(x(N)*a+b)
	sum=sum+del**2
	ENDDO
	rmse=sqrt(sum/nut)
C
	RETURN
	END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++