	program histhcomap
C .......................................................Sep. 2020
C Selection for Dst storms !!!!!!!!!!!!!!!!!!!!!!!!
C
C during (1) Dst storm onset
C        (2) Dst storm peak
c .......................................................Feb 2015
C Histogram of monthly & annual dev=Hc-Hcmed) occurrence 
C                  from 71 glat vs 0:72 glon coMNDYUT.jYR maps
C Hc monthly median is wrong. Re-calculate with running 27-days median (subroutine rmedian27.for)
C
c input annual files collected for UT: 0, 1, 2, ...,23 hrs UT
c from IONEX maps
c
	DIMENSION idat(0:24),icntmn(15),icntyr(15),ictot(15),IM(12)
	+,ITR(15),res(15) !*100%
	+,idst1(8,530),adst(530) 
	CHARACTER*64,infile,outfile, infdst
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*4 AYEAR
	DATA ITR/-10,-7,-5,-4,-3,-2,-1,0,1,2,3,4,5,7,10/
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	common /BLOK/idst1,adst 
C
	infdst='dststorm2.txt'
c 1247 DST9901*13 17  DST9901*13 23 -112.  DST9901*15 20   52
   33 format(9X,2I2,2(1X,I2),5X,2I2,2(1X,I2),1X,F5.0)
	OPEN(11,FILE=INFDST,action='READ')
	icdst=0
	do ii=1,530
C      read(15,33,end=27,err=27) IYR1,IMN1,IDY1,IUT1,IYR1,IMN2,IDY2,IUT2
c 	+,DST
      read(11,33,end=27,err=27) IDST1(1,ii),IDST1(2,ii),IDST1(3,ii)
	+,IDST1(4,ii),IDST1(5,ii),IDST1(6,ii),IDST1(7,ii),IDST1(8,ii)
 	+,ADST(ii)
	 icdst=icdst+1       ! Count Dst storm number
      enddo
   27	close(unit=11)
	outfile='histcodst2.txt'
      OPEN(112,FILE=OUTFILE,ACCESS='APPEND')
	iflag=1

C Start (1) for Dst start; (2) for Dst peak
1234	iyyyy=1993
	ndst=1  !  Dst storm events = 1,2,...,icdst
	infile='d:\web\dhc\YR\mapdeYRco.txt'
C
	do k=1,15
	ictot(k)=0
	enddo
C start cycle on Year
 100	iyyyy=iyyyy+1
	do k=1,15
	icntyr(k)=0
	enddo

	if (iyyyy.gt.2014) goto 801 ! total result =>

	year=float(iyyyy)
	if(int(year/4.)*4.eq.iyyyy) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF
C
	call blet4(iyyyy,AYEAR)
C
	AYR=ayear(3:4)
	iyr=iyyyy-(iyyyy/100)*100
C
	infile(12:13)=AYR
	infile(28:29)=AYR
C
C Cycle on MONTH
	DO 171 imn=1,12
	ndays=im(imn)
	call blet2(imn,AMN)
	infile(15:16)=AMN
	infile(20:21)=AMN

	do k=1,15
	icntmn(k)=0
	enddo
	cmon=5112.0*24.0*ndays
C
200   continue	  !

C Cycle onday-to-day
	DO 172 idy=1,ndays
	call blet2(idy,ADY)
	infile(22:23)=ADY

C start cycle on UT
	do 201 iut=0,23
	call blet2(iut,AUT)
	infile(24:25)=AUT

C start
C Select current Dst event
	if (ndst.gt.icdst) GOTO 201     !end of calculations
C		
	call subdst(iflag,ndst,iyrc,imnc,idyc,iutc)
	if ((iyr.ne.iyrc).or.(imn.ne.imnc).or.(idy.ne.idyc)
	+.or.(iut.ne.iutc)) GOTO 201
C
	ndst=ndst+1
c	if (ndst.gt.icdst) GOTO 201
	OPEN(111,FILE=INFILE)
c     
C  Input datafile 
	glat=-90.0
	do 123 ilat=1,71
	glat=glat+2.5
c
    1	READ (111,12,END=55,ERR=2) (idat(k),k=0,71)
  12	FORMAT(72(1X,I4))
	if ((glat.lt.-20.0).or.(glat.gt.20.0)) GOTO 123  ! Area results
C Selected latitudes start here:
	glon=-185.
	DO 202 kt=0,71
	glon=glon+5.
	alon=glon
	if (alon.lt.0.0) alon=alon+360.
	if ((alon.lt.90.).or.(alon.gt.190.)) goto 202		 ! Area results
C Selected longitudes:
	if (idat(kt).le.itr(1)) then
	icntmn(1)=icntmn(1)+1
	goto 202
	endif
	if (idat(kt).eq.0) then
	icntmn(8)=icntmn(8)+1
	goto 202
	endif
	if (idat(kt).ge.itr(15)) then
	icntmn(15)=icntmn(15)+1
	goto 202
	endif
	do ii=1,7
	if ((idat(kt).gt.itr(ii)).and.(idat(kt).le.itr(ii+1))) then
	 icntmn(ii)=icntmn(ii)+1
	endif
	enddo
	do ii=9,15
	if ((idat(kt).ge.itr(ii-1)).and.(idat(kt).lt.itr(ii))) then
	 icntmn(ii)=icntmn(ii)+1
	endif
	enddo
 202	CONTINUE
123	CONTINUE       ! cycle on latitudes
  55   CLOSE(unit=111)

201   CONTINUE       ! Cycle on UT

172   CONTINUE       ! Cycle on day-to-day
	do i=1,15
	icntyr(i)=icntyr(i)+icntmn(i)
	enddo
   72 format(1X,2A2,15(1X,F6.2))

C 
c   
  171 CONTINUE             ! Month-to-month cycle 
	do i=1,15
	ictot(i)=ictot(i)+icntyr(i)
	enddo
	goto 100           !  GO TO NEXT YEAR

  801 continue            ! 
C output annual results for MLAT (all 12 UT bins)
	total=0.
	do i=1,15
	total=total+float(ictot(i))
	enddo
	do i=1,15
	res(i)=ictot(i)/total*100.    !average occurrence for 1999-2014%
	enddo
	ayr='00'
	amn='00'
  802	write(112,72) ayr,amn,(res(k),k=1,15)
 	 write(*,72) ayr,amn,(res(k),k=1,15)
c-	pause ' '
		 if (iflag.eq.1) then
 	 iflag=2
	 goto 1234
	 endif

C
   75 continue	 

	CLOSE(unit=112)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

	subroutine subdst(ifl,iidst,iyrc,imnc,idyc,iutc)
	dimension idst2(8,330),bdst(330) 
	common /BLOK/idst2,bdst 
c	iidst=iidst+1       ! read Dst event
	iyr1=IDST2(1,iidst)
	imn1=IDST2(2,iidst)
	idy1=IDST2(3,iidst)
	iut1=IDST2(4,iidst)
	iyr2=IDST2(5,iidst)
	imn2=IDST2(6,iidst)
	idy2=IDST2(7,iidst)
	iut2=IDST2(8,iidst)
 	XDST=bDST(iidst)
	if (ifl.eq.1) then
	iyrc=iyr1
	imnc=imn1
	idyc=idy1
	iutc=iut1
	               else
	iyrc=iyr2
	imnc=imn2
	idyc=idy2
	iutc=iut2
                     endif
					 RETURN
					 end