      program solphase4s12
C........................................................Jul. 2022
C
C .......................................................Sep. 2018
C Include prediction to peak of SC25 2024/01
C........................................................Aug 2018
C Fi >0 at growing phase, Fi <0 at descending phase
C
C SolPhase for SSN1 and COV monthly 
C
Crem	dimension RMIN(8),RMAX(8)
	dimension RMIN(9),RMAX(9)
	character*65 infilerz,infilecv, outfile1, outfile2
	integer*2 iyr,imn
	character*2 AYR,AMN
	character*4 AYEAR
Crem	DATA RMIN/1944.2,1954.3,1964.9,1976.5,1986.8,1996.9,2008.9,2018.7/
Crem	DATA RMAX/1937.4,1947.5,1957.9,1968.9,1979.9,1989.6,2000.3,2014.5/
	DATA RMIN/1944.2,1954.3,1964.9,1976.5,1986.8,1996.9,2008.9,2019.9
	+,2034.1/
	DATA RMAX/1937.4,1947.5,1957.9,1968.9,1979.9,1989.6,2000.3,2014.5
	+,2025.5/
C-- 
c//	infile='covrzmon.txt'	  ! monthly Rz and F10.7
C	infile='cov12rz.txt'	  !12-monthly Rz and F10.7
	infilerz='ssn1_12.res'	  !12-monthly Rz
		infilecv='cov_12.res'	  !12-monthly F10.7
	outfile1='solphaserz12.txt'
	outfile2='solphasecv12.txt'
C
   71	format(A45)
   72	format(I4,I2,1X,F6.1)
C
      OPEN(10,FILE=INFILERZ,action='READ')
	OPEN(11,FILE=INFILECV,action='READ')
	   	OPEN(12,FILE=OUTFILE1)
	OPEN(13,FILE=OUTFILE2)
C
  121 FORMAT(1X,A4,A2,1X,F5.2,1X,F7.1,1X,I4)
  122	FORMAT(A6)
  123	FORMAT(12(1X,I4))
  124	FORMAT(A64)

C Cycle on years : 1947/08-2019/07
C
	iyyyy=1993
	do KK=1,31
      iyyyy=iyyyy+1
	call blet4(iyyyy,AYEAR)
	AYR=AYEAR(3:4)
	read(ayr,*) ryr
	iyr=int(ryr)
C  Cycle on mn
C
	imn1=1
      imnend=12
	iflag=0
Crem	if (iyyyy.eq.2018) imnend=8 ! Jul 2018
	if (iyyyy.eq.2025) imnend=6 ! June 2025 (SC25 max)
C
	do 55 imn=imn1,imnend	 ! <<<<<<<<<<<<<<<<<<<<<<<<
	ryear=iyyyy+imn/12.-0.083
	call blet2(imn,AMN)
C	if (iflag.eq.1) goto 39
C Monthly count of occurrence
C   1	read(11,72,end=39) kyear,kmn,cv,rz
   1	read(10,72,end=39) kyear,kmn,rz
      read(11,72,end=39) kyear,kmn,cv
      if (kyear.lt.iyyyy) goto 1
	if (iflag.eq.1) goto 39
	if ((kyear.eq.2022).and.(kmn.eq.1))	then   !!! CORRECT LAST+1 MONTH!!!
	goto 39
	else
      goto 22
	endif
C prediction for SC25
   39	iflag=1
      rz=-1.
	cv=-1.
C
   22	rmn=float(imn)
	ASTR=ryr+rmn/12.
	if(iyr.lt.30) then
	ASTR=ASTR+2000.
	else
	ASTR=ASTR+1900.
	endif
C Select Sol Phase boundaries
Crem	do j=1,8
	do j=1,9
	if ((ASTR.le.RMIN(j)).and.(ASTR.ge.RMAX(j))) then
C descending phase (fi < 0)
	AMIN=RMIN(j)
	AMAX=RMAX(j)
	coef=-1.
	goto 149
	endif
	enddo
Crem	do j=1,7
	do j=1,8
	if ((ASTR.ge.RMIN(j)).and.(ASTR.le.RMAX(j+1))) then
C growing phase (fi > 0)
	amin=RMIN(j)
	amax=rmax(j+1)
	coef=1.
	exit
	endif
	enddo
C end select
  149  FI=coef*(ASTR-AMIN)/(AMAX-AMIN)
	if (iflag.eq.0) goto 150
C
C Predict SC25
C++       rz =FI*(67.66*FI-7.0302)+6.2404
CSep2018       rz =FI*(67.66*FI-7.0302)+6.2404  ! ?+9.2404 !
CNov-1      rz =FI*(70.498*FI-8.0548)+0.4234  !Nov. 2018 from 12-month smoothed
C++      rz =FI*(73.6751*FI-4.8145)+0.0434  !Nov. 2018 from monthly data up 2018.10
C--      rz =FI*(74.0*FI-4.8)+0.011  !Nov. 2018 from 12-monthly data up 2018.10
	x=FI
C-       p1 =       -10.4
C-       p2 =       69.14
C-       p3 =       1.703
C-       p4 =       2.615
C     rz=x*(p3+x*(p2+x*p1))+p4  !Dec. 2019 from 12-monthly data up 2019.06C
C 2014.06-2020.06	   = JAN 2021
C
c_       p1 =       8.625
c_       p2 =      0.5622
c_       p3 =       77.75
c_       p4 =       7.431
c_       p5 =       2.191
c_      rz =x*(p4+x*(p3+x*(p2+x*p1)))+p5  !from 12-monthly data 2014.06 - 2020.06
C 2021.07.02
C             p1 =      -7.907
C       p2 =        77.5
C       p3 =       8.232
C       p4 =       2.546
C	rz =x*(p3+x*(p2+x*p1))+p4 	! 2014.06-2020.12
C 2022.01.12
C       p1 =      -39.57
C       p2 =      -40.07
C       p3 =       20.07
C       p4 =       118.4
C       p5 =       19.28
C       p6 =       2.477
C 2022.08.06           ! from 2008.11 to SC25 peak SSN1max=85.0
       a1 =         314
       b1 =       1.725
       c1 =       1.742
       a2 =       313.9
       b2 =       1.979
       c2 =      -1.365
       a3 =        6.91
       b3 =       11.15
       c3 =      -5.098
       a4 =       8.893
       b4 =       9.631
       c4 =      -2.465
C
	rz=a1*sin(b1*x+c1)+a2*sin(b2*x+c2)+a3*sin(b3*x+c3)+a4*sin(b4*x+c4) 	! 2008.11-2022.01+2025.06

Crem	cv=FI*(72.6642 -10.1848)+67.7378
C++       cv=1.0202*rz+61.62
C--      cv=FI*(FI*(-31.19*FI+71.0)+20.22)+71.08
c-     p1 =      -31.02
c-     p2 =        70.4
c-     p3 =       19.01
c-     p4 =       70.75
c-    cv =x*(p3+x*(p2+x*p1))+p4  !Dec. 2019 from 12-monthly data up 2019.06
C
C 2014.06-2020.06
C
c_       p1 =       15.29
c_       p2 =      -18.83
c_       p3 =       66.93
c_       p4 =        17.5
c_       p5 =       69.71
c_      cv =x*(p4+x*(p3+x*(p2+x*p1)))+p5  ! from 12-monthly data 2014.06 - 2020.06
C       p1 =      -22.41
C       p2 =       81.95
C       p3 =       22.82
C       p4 =        69.6
C 2008.11-2022.01		cov(ssn1)
       p1 =    0.002741
       p2 =      0.7415
       p3 =       67.52

       cv =p1*rz**2 + p2*rz + p3  ! 2008.11-2022.01

C-NO!       cv=FI*(78.0333 -7.8612)+61.1882 ! Nov. 2018 from monthly data up 2018.10
c	num=keq(imn)
c	if (num.eq.0) goto 151
  150 write(*,13) ryear,AMN,fi,rz
	write(12,13) ryear,AMN,fi,rz
	write(*,13) ryear,AMN,fi,cv
	write(13,13) ryear,AMN,fi,cv
  13  FORMAT(1X,F8.2,1X,A2,1X,F7.2,1X,F6.1)
  151	continue
  55	continue          !<<<<<<<<<<<<<<<<<<<<<<<<	   ! end cycle on month
	ENDDO					   ! end cycle on year
    3	CLOSE(unit=10)
      CLOSE(unit=11)
	CLOSE(unit=12)
	CLOSE(unit=13)
	goto 180
C	goto 1
    2	write(*,*) 'input error'
	
180   continue
	pause ' '
      STOP
	end