      program ext1hjpl35
C........................................................Aug. 2021
C Extract 1h W-indices along glon=35E (wc) or mlong=120E (wo) Moscow meridiands for 3 days
      integer kn,nday,ivsr(71,0:23),IM(12) ! ivsr along glon for 00,01,...,23h
     +,ivs(73),ires(71,0:71)
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*4 AGLON
	CHARACTER*5 AGLONG
      CHARACTER*128 INFILEV,outfile
	CHARACTER*1 wco
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
c	DATA WEG/0.,0.6931,1.0986,1.3863/  ! =ln1, ln2, ln3, ln4
C++
C        wco='c'       ! geogr
	wco='o'         ! geomagn
        if (wco.eq.'c') then
      	glon=35.0  !selected longitude 35E-meridian
	iglon=int(glon)
	      else
	glon=120.0
	iglon=nint(glon)
	      endif
C
 	if (iglon.lt.0) then 
 	mglon=-iglon
	call blet3(mglon,AGLON)
	AGLONG(1:1)='-'
	AGLONG(2:4)=AGLON
	else
	call blet3(iglon,AGLON)
	AGLONG(1:1)=wco
	AGLONG(2:4)=AGLON
	      endif
C 
       WRITE(*,*) ' Enter YR: '
	read(*,*) AYR
	read(AYR,*) ryr
	iyr=int(ryr)
	if(int(ryr/4.)*4.eq.iyr) THEN 
 	im(2)=29
	                          ELSE
	im(2)=28
	ENDIF
C
       WRITE(*,*) ' Enter MN: '
	read(*,*) imn
C
       WRITE(*,*) ' Enter idy1,idy2: '
	read(*,*) idy1,idy2
C
	outfile='wxGLON.jyr'
       outfile(2:2)=wco
	outfile(3:6)=AGLONG
	outfile(9:10)=AYR
C
   30 FORMAT(1X,2A2,1X,I2,1X,F6.1)
   31 FORMAT(73(1X,I4))
   32 FORMAT(24(1X,I4))
C
	OPEN(14,file=outfile,access='APPEND')
C
	infilev='D:\web\dws\YR\MN\wxMNDDUT.jYR'
      infilev(19:19)=wco
	infilev(12:13)=AYR
	infilev(28:29)=AYR
C
	call blet2(imn,AMN)
	infilev(15:16)=AMN
	infilev(20:21)=AMN
C day-to-day cycle
c       DO 40 idy=1,ndmn
        nday=0
	kn=0
       DO 40 idy=idy1,idy2
	nday=nday+1
	kn=(nday-1)*8
	CALL blet2(idy,ADY)
	infilev(22:23)=ADY
C
       nn=0           ! cnt hr for given day
C UT cycle  
C Read maps for 3successive hours
       DO 41 iut=0,23
	call blet2(iut,AUT)
	infilev(24:25)=AUT
C
	nn=nn+1
	OPEN(12,file=infilev,action='READ')
C
      xlat=-90.0
	coglon=360.-glon
C lati cycle
	DO nlat=1,71
	xlat=xlat+2.5
	coxlat=87.5-xlat
	read(12,31,end=46) ivs
C
      xlon=-185.0
	DO nlon=0,72
	xlon=xlon+5.0
	coxlon=360.-xlon
	if (abs(coxlon-coglon).le.2.5) then  ! +++
      ivsr(nlat,iut)=ivs(nlon)
      exit
	endif					! +++
	ENDDO   ! long cycle
C
	ENDDO	  ! lat cycle
   46		 close(unit=12)
   41 CONTINUE		 ! UT cycle
C
C lati cycle
       glat=-90.0	                  ! AD
	 DO 333 ilat=1,71
 	glat=glat+2.5				  ! AD
C
	write(*,33) AYR,AMN,ADY,glat,(ivsr(ilat,k),k=0,23)
	write(14,33) AYR,AMN,ADY,glat,(ivsr(ilat,k),k=0,23)
  333	CONTINUE
C
C
   40 continue ! day-to-day cycle
      close(unit=14)
C
C combine for 3 days
      OPEN(10,file=outfile,action='READ')
	DO kk=1,3
	k1=(kk-1)*24
	   do ilat=1,71
	read(10,33,end=201) AYR,AMN,ADY,glat,(ivsr(ilat,k),k=0,23)
	do iut=0,23
	k2=k1+iut
	ires(ilat,k2)=ivsr(ilat,iut)
	   enddo
	enddo
	ENDDO
  201 close(unit=10)
C
	OPEN(14,file=outfile,access='APPEND')
       glat=-90.0	                  ! AD
	 DO ilat=1,71
 	glat=glat+2.5				  ! AD
	write(*,133) AYR,AMN,glat,(ires(ilat,k),k=0,71)
	write(14,133) AYR,AMN,glat,(ires(ilat,k),k=0,71)
	ENDDO
	close(unit=14)
   33 FORMAT(1X,3A2,1X,F5.1,24(1X,I2))
  133 FORMAT(1X,2A2,1X,F5.1,72(1X,I2))
      pause ' '
	stop
	end