      program ext3hjpl35
C........................................................Aug. 2021
C Extract 3h WU,WL,WE-indices along glon=35E (wc) or mlong=120E (wo) Moscow meridiands for 3 days
      integer kn,nday,ivsr(0:23),IM(12) ! ivsr along glon for 00,01,...,23h
     +,ivs(73),iwures(0:7),iwlres(0:7),iweres(0:7)  ! 1days of 3h indices at each lati
      dimension weg(4) ! 3h indices
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*4 AGLON
	CHARACTER*5 AGLONG
      CHARACTER*128 INFILEV,outfilep,outfilen,outfiler
	CHARACTER*1 wco
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA WEG/0.,0.6931,1.0986,1.3863/  ! =ln1, ln2, ln3, ln4
C++
        wco='c'       ! geogr
C	wco='o'         ! geomagn
        if (wco.eq.'c') then
      	glon=35.0  !selected longitude 35E-meridian
	iglon=int(glon)
	      else
	glon=120.0
	      endif
C
 	if (iglon.lt.0) then 
 	mglon=-iglon
	call blet3(mglon,AGLON)
	AGLONG(1:1)='-'
	AGLONG(2:4)=AGLON
	else
	call blet3(iglon,AGLON)
	AGLONG(1:1)='t'
	AGLONG(2:4)=AGLON
	      endif
C 
       WRITE(*,*) ' Enter YR: '
	read(*,*) AYR
	read(AYR,*) ryr
	iyr=int(ryr)
	if(int(ryr/4.)*4.eq.iyr) THEN 
 	im(2)=29
	                          ELSE
	im(2)=28
	ENDIF
C
       WRITE(*,*) ' Enter MN: '
	read(*,*) imn
C
       WRITE(*,*) ' Enter idy1,idy2: '
	read(*,*) idy1,idy2
C
	outfilep='wxGLONp.jyr'
       outfilep(2:2)=wco
	outfilep(3:6)=AGLONG
      outfilep(9:10)=AYR
	outfilen=outfilep
	outfilen(7:7)='n'
	outfiler=outfilep
	outfiler(7:7)='r'
C
   30 FORMAT(1X,2A2,1X,I2,1X,F6.1)
   31 FORMAT(73(1X,I4))
   32 FORMAT(24(1X,I4))
C
	OPEN(14,file=outfilep,access='APPEND')
	OPEN(15,file=outfilen,access='APPEND')
	OPEN(16,file=outfiler,access='APPEND')
C
	infilev='D:\web\dws\YR\MN\wxMNDDUT.jYR'
      infilev(19:19)=wco
	infilev(12:13)=AYR
	infilev(28:29)=AYR
C
	call blet2(imn,AMN)
	infilev(15:16)=AMN
	infilev(20:21)=AMN
C day-to-day cycle
c       DO 40 idy=1,ndmn
        nday=0
	kn=0
       DO 40 idy=idy1,idy2
	nday=nday+1
	kn=(nday-1)*8
	CALL blet2(idy,ADY)
	infilev(22:23)=ADY
C
       nn=0           ! cnt hr for given day
C UT cycle  
C Read maps for 3successive hours
       DO 41 iut=0,23
	call blet2(iut,AUT)
	infilev(24:25)=AUT
C
	nn=nn+1
	OPEN(12,file=infilev,action='READ')
C
      xlat=-90.0
	coglon=360.-glon
C lati cycle
	DO nlat=1,71
	xlat=xlat+2.5
	coxlat=87.5-xlat
	read(12,31,end=46) ivs
C
      xlon=-185.0
	DO nlon=0,72
	xlon=xlon+5.0
	coxlon=360.-xlon
	if (abs(coxlon-coglon).le.2.5) then  ! +++
      ivsr(iut)=ivs(nlon)
      exit
	endif					! +++
	ENDDO   ! long cycle
C
	ENDDO	  ! lat cycle
   46		 close(unit=12)
   41 CONTINUE		 ! UT cycle
C
C 3-h indices
C lati cycle
       glat=-90.0	                  ! AD
	 DO 333 ilat=1,71
 	glat=glat+2.5				  ! AD
 	elat=1.0+0.0001235*glat**2	  ! AD
      dypos=0.
	dyneg=0.
	sumn=0.		 !3h count of Vs >1
	sump=0.		 !3h count of Vs <-1
	icntp=0
	swegp=0.
      icntn=0
	swegn=0.
        do kk=0,23
      iwures(kk)=0
	iwlres(kk)=0
	iweres(kk)=0
	enddo
C
	DO 332 ihr=1,8   ! 8 3-h intervals
	kn=ihr-1
	k1=(ihr-1)*3
	k2=k1+2
C
       DO 331 kk=k1,k2			 !**
          if (ivsr(kk).gt.1) then
        iad=ivsr(kk)
	sump=sump+elat*weg(iad)*ivsr(kk)
	icntp=icntp+1
	swegp=swegp+weg(iad)
	goto 331
	endif
          if (ivsr(kk).lt.-1) then
        iad=-ivsr(kk)
	sumn=sumn+elat*weg(iad)*ivsr(kk)
	icntn=icntn+1
	swegn=swegn+weg(iad)
	goto 331
	endif
 331	CONTINUE			!**
      xpos=0.
      if (icntp.gt.0.) then
C		xpos=sump/swegp		 ! /sum(weights)
		xpos=sump/icntp		 ! /cnt(W+)
	endif
      xneg=0.
      if (icntn.gt.0.) then
C			xneg=sumn/swegn	  ! /sum(weights)
			xneg=sumn/icntn	  ! /cnt(W-)
	endif
	xrange=xpos-xneg
	iwures(kn)=nint(xpos*100.)
	iwlres(kn)=nint(xneg*100.)
	iweres(kn)=nint(xrange*100.)
  332	CONTINUE                   ! end 8 3-h intervals
	write(*,33) AYR,AMN,ADY,glat,(iwures(k),k=0,7)
	write(14,33) AYR,AMN,ADY,glat,(iwures(k),k=0,7)
	write(*,33) AYR,AMN,ADY,glat,(iwlres(k),k=0,7)
	write(15,33) AYR,AMN,ADY,glat,(iwlres(k),k=0,7)
	write(*,33) AYR,AMN,ADY,glat,(iweres(k),k=0,7)
	write(16,33) AYR,AMN,ADY,glat,(iweres(k),k=0,7)
  333	CONTINUE
C
C
   40 continue ! day-to-day cycle
      close(unit=14)
	close(unit=15)
	close(unit=16)
   33 FORMAT(1X,3A2,1X,F5.1,8(1X,I5))
      pause ' '
	stop
	end