C .......................................................July 2020
C Input: 
C
C
C Extract hmF2, Hc for given 14 IGS stations from GIM-hmF2, GIM-Hc in magn,coord. (0:5:360E)
C
C 
C Output: C:/msdev/projects/counts/statYRMNDDLT.txt
C
C + Average for 14 stations
C
      PROGRAM EXTRAhmhc1
C---------------------------------------------------------------
C data for 24 UT=0,1,2,...23hUT daily
C
C
C*********TEST
	CHARACTER*128 outfile
	character*2 ayr,amn
	+,ADY,AUT,ALT
      REAL GMLATS(14),GMLONS(14),hm(372),hcm(372),hp(372) 
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*1 fht
	CHARACTER*4 STAT,STATS(14)
	CHARACTER*4 AYEAR
	dimension im(12)
     +,idd(14),itt(14)
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
		DATA STATS/
     + 'WSRT','GRAZ','SUTH','GLSV','URUM','BJFS','ALIC'
     +,'MOBS','TOW2','COSO','PRDS','NIST','GODE','CAGS'/
C      
	DATA GMLATS/
C Mlati
     +  53.6,  46.5, -32.5,  47.3,  34.4,  30.0, -32.3
	+, -45.2,-26.6,  42.5,  57.6,  47.9,  48.7,  55.3/
      DATA GMLONS/
C Mlong
     +   92.2,  98.5,  87.2, 113.7, 162.7, 187.6, 208.9
     +, 223.2, 222.4, 308.9, 308.5, 321.9, 355.1, 356.1/
C
	DATA idd/
	+ 17, 16, 16, 16, 16, 16, 16
	+,16, 16, 17, 17, 17, 17, 17/
C
	DATA itt/
	+ 00, 23, 23, 22, 18, 16, 15
	+,14, 14,  8,  8,  7,  5,  5/
  113	FORMAT(A128)
c
	      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
C      
       AYEAR='2017' !temp Quiet day
C      AYEAR='2015' !temp Patrick-Day-Storm
	AMN='03'
C	ADY='17'
C
	AYR=AYEAR(3:4)
	read(ayr,*) yr
	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF
  76	format('%',1X,A4,2(1X,F5.1))
C
	outfile='statYRMN.txt'
	outfile(5:6)=AYR
	outfile(7:8)=AMN
C+++++++++++Average for 14 stations
      do kk=1,372  ! Ave
	hm(kk)=0.	 ! Ave
	hcm(kk)=0.	 ! Ave
	enddo		 ! Ave
C
      DO 56 ist=1,14
	glat=gmlats(ist)
	glon=gmlons(ist)
	stat=stats(ist)
Cnorm	outfile(1:4)=stat

	id0=idd(ist)
	it0=itt(ist)
C
	iut=it0-1
	idy=id0

	OPEN(20,file=outfile,access='APPEND')
	DO 55 lt=0,23
	call blet2(lt,ALT)
	iut=iut+1
	if (iut.gt.23) then
	iut=0
	idy=idy+1
	endif
	call blet2(idy,ADY)
	call blet2(iut,AUT)
c-      outfile(7:8)=ADY
c-	outfile(9:10)=ALT
	if (lt.eq.0) then
	write(*,76) stat,glat,glon
c-	write(20,76) stat,glat,glon
      endif
C
	fht='h'
      call subinterp2m(fht,glat,glon,ayr,amn,ady,aut,res)
	hmf2=res
	fht='c'
	call subinterp2m(fht,glat,glon,ayr,amn,ady,aut,res)
	hc=res
	dev=hc-hmf2
Crem	hm(lt+1)=hmf2	  !
      hm(lt+1)=hm(lt+1)+hmF2
Crem	hcm(lt+1)=hc
       hcm(lt+1)=hcm(lt+1)+hc
Cnorm	write(*,30) idy,iut,lt,hmf2,hc,dev
Cnorm	write(20,30) idy,iut,lt,hmf2,hc,dev
C
C
C
   30	format(3(1X,I2),3(1X,F5.1))
   33	format(1X,I2,3(1X,F5.1))
   55	CONTINUE  ! next LT

   56	CONTINUE  ! next stat
      do kk=0,23
	hmf2=hm(kk+1)/14.
	hm(kk+1)=hmf2
	hc=hcm(kk+1)/14.
	hcm(kk+1)=hc
	dev=hc-hmf2
	write(*,33) kk,hmf2,hc,dev
	write(20,33) kk,hmf2,hc,dev
	enddo
      call subrmscor1(24,hm,hcm,cor,rms,xav,yav,areg,creg)
C Add RMSE according to polyfit1:
      dev=0.
	do k=1,24       ! ncor
	hp(k)=areg*hm(k)+creg
	dev=dev+(hcm(k)-hp(k))**2
	enddo
      rmse=sqrt(dev/24.)
	write(*,31) AYR,AMN,cor,rms,xav,yav,areg,creg,rmse
	write(20,31) AYR,AMN,cor,rms,xav,yav,areg,creg,rmse
   71   close(unit=20)

C
C+   56	CONTINUE  ! next stat
   31 format(1X,2A2,1X,F7.3,1X,F7.2,2(1X,F6.1),1X,F7.3,1X,F6.1,1X,F7.3)
C
    2 CONTINUE
      pause ' ' 
   34   STOP
       END

C***********************************************************
