c     Indices
C...............................................................................Nov 2021
C SN_R.dat ----------------- daily index data file
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c .. Input:
c ..    day                           (integer)
c .    month                          (integer)
c .     year                          (integer)
c .     nday - day number of the year (integer)
c
c .  Output:
c .    Rt - integral index of solar activity for 27 days - 1 revolution of the Sun (real)
CC      call R_tau(idayut,monthut,iyearut,Ri,Rt) !+TLG
CC      subroutine R_tau(day,month,year,Ri,Rt)
cc-----------------------------------------------------------------------
      program indices27d
C produce 27d running indices: F10.7, Lyman-a
C SN_R.dat ----------------- daily index data file
C
 	CHARACTER*64 outfile
	CHARACTER*2 AMN,ADY
	CHARACTER*4 AYEAR,MMDD
C 	implicit none
c     .. scalar arguments ..
C      integer iday, month, iyear
C			real UT
	real Ri,Rt,R27
c
c     .. scalar arguments ..
c     .. local scalars ..
c-	integer  i_R
	integer ns, nd
      real Wsum, Wk, wta, wta0, ww
      real Wsumo,ssn(0:28)
      real:: tauR27=0.9623  ! 27 day
	integer k
C>        integer iny_R
        integer n_R
	  data n_R/10/
	  character(256) file_R 
C	  data file_R/'SN_R.dat'/
C+
	  data file_R/'Lymady.txt'/          ! Lyman-a
C+
        outfile='Lyman-27.txt'				! Lyman-a
	OPEN(11,file=outfile)
C+
c      
      open(unit=10,file=file_R,action='READ')   ! +TLG
C-	read(10,*,err=5) iyear,imndy,alpha
C-		read(10,*,err=5) txt
C-		read(10,*,err=5) txt
c      
C?	jd=mod(iny_R-1,4)
       iny_R=0
	wta0=1.0e-03
	NS = int(1.0/(1.0-tauR27))
C?      idyear = iyear - iny_R
C?	nday=ndoy(iyear,month,iday)  !=========>>>>>>>>>>>>>>>>>>>
C?	irec = dyear*365 + (dyear+jd)/4 + nday
      ww = 1.0
	wta = 1.0
	Wsumo = 0.0
	Wsum = 0.0
C      do nd=0,NS
C	   read(n_R,10,rec=irec,err=5) w_year,w_month,w_day,year_decimal,
C     &                                                       i_R,SD,nn
C    1	read(n_R,10,err=5) w_year,w_month,w_day,year_decimal,i_R   ! TLG
C     +,SD,nn													   ! TLG
C++
C???      NS=27
	nd_inp=0
C    1	read(n_R,10,err=5) AYEAR,AMN,ADY,i_R			  ! Lym-a
    1	read(10,*,err=5,end=6) iyear,imndy,alpha			  ! Lym-a
      call blet4(iyear,AYEAR)
      call blet4(imndy,MMDD)
      AMN=MMDD(1:2)
	ADY=MMDD(3:4)
C  NEW TLG:
	nd_inp=nd_inp+1
      ssn(0)=alpha
C--	if ((w_year.eq.year).and.(w_month.eq.month).and.(w_day.eq.day)) 
 	if(nd_inp.eq.NS) then
	 goto 2
	    else
C Move data forward by 1 day:
	do k=28,1,-1
	ssn(k)=ssn(k-1)
	enddo
	goto 1
	endif
    2          do nd=0,NS
C             if (nd.eq.0) Ri=i_R
         if (nd.eq.0) Ri=ssn(0)
C	            irec = irec - 1
	Wk=ssn(nd+1)
C	         Wk = i_R
	   if (tauR27.le.0.) then
            Rt =  Wk
C-            return
       goto 3
         end if
	   Wsumo = Wsumo + wta
	   if (nd==0) then
	      Wsum = Wsum + Wk
	   else
	      Wsum = Wsum + Wk * wta
	   end if
	   wta = wta * tauR27
      enddo
      Rt = Wsum/Wsumo
c
	      R27 = (2.0*Rt+Ri)/3.0
	write(*,10) ayear,amn,ady,R27
	write(11,10) ayear,amn,ady,R27
      nd_inp=nd_inp-1
C Move data forward by 1 day:
	do k=28,1,-1
	ssn(k)=ssn(k-1)
	enddo
      ww = 1.0
	wta = 1.0
	Wsumo = 0.0
	Wsum = 0.0
	GOTO 1
c      return
c
   3	close(n_R)
      close(11)
	GOTO 6
  10  format(A4,1X,2(A2),2X,F9.7)          ! Lym=a
  80  format(4x,'Not file:',a50)
 100  format(4x,'Error in file: SN_R.dat')
C  10  format(i4,2(1x,i2),1x,f8.3,1x,i4,1x,f5.1,1x,i4)  !SSN2-daily
C-      end subroutine R_tau 
C
   5 	print 100
C
   6	pause ' '
      STOP
	END
c
C--------------------------------------------------------------------------
