c     Indices
C...............................................................................Nov 2021
C SN_R.dat ----------------- daily index data file
CC Ytau27=(1-tau)/(1-tau**n)*(F0+tau*F_1+tau**2*F_2...+tau**29*F_26) =smoothed Index(tau) 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c .. Input:
c ..    day                           (integer)
c .    month                          (integer)
c .     year                          (integer)
c .     nday - day number of the year (integer)
c
c .  Output:
c .    R27 - integral index of solar activity for 27 days - 1 revolution of the Sun (real)
cc-----------------------------------------------------------------------
      program indices27d0
C produce 27d running indices: F10.7, Lyman-a
C SN_R.dat ----------------- daily index data file
C
 	CHARACTER*64 infile,outfile
	CHARACTER*2 AMN,ADY
	CHARACTER*4 AYEAR,MMDD
	real R27
c
	integer ns, k
      real ssn(0:28)
C      real:: tauR27=0.9623  ! 27 day
C+
         infile='Lymady.txt'          ! Lyman-a
        outfile='Lyman-27d.txt'				! Lyman-a
	OPEN(11,file=outfile)
C+
c      
      open(unit=10,file=infile,action='READ')   ! +TLG
c      
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	tau=0.9623
      tau=exp(-1./26.)
	NS = int(1.0/(1.0-tau))
	nd_inp=0
C    1	read(n_R,10,err=5) AYEAR,AMN,ADY,i_R			  ! Lym-a
    1	read(10,*,err=5,end=6) iyear,imndy,alpha			  ! Lym-a
      call blet4(iyear,AYEAR)
      call blet4(imndy,MMDD)
      AMN=MMDD(1:2)
	ADY=MMDD(3:4)
C  NEW TLG:
	nd_inp=nd_inp+1
      ssn(0)=alpha
C--	if ((w_year.eq.year).and.(w_month.eq.month).and.(w_day.eq.day)) 
 	if(nd_inp.eq.NS+1) then
	 goto 2
	    else
C Move data forward by 1 day:
	do k=28,1,-1
	ssn(k)=ssn(k-1)
	enddo
	goto 1
	endif
    2       	fsum=0.
	STAU=1.
      icnv=0 			   
  207 Ftau=0.0
      Rtau=0.0
            do k=0,26
	fsum=fsum+stau*ssn(k)
	stau=stau*0.9623
      enddo
	coef=(1.-tau)/(1.-stau)
	R27=coef*fsum
c
C	      R27 = (2.0*Rt+Ri)/3.0
	write(*,10) ayear,amn,ady,R27
	write(11,10) ayear,amn,ady,R27
      nd_inp=nd_inp-1
C Move data forward by 1 day:
	do k=28,1,-1
	ssn(k)=ssn(k-1)
	enddo
	GOTO 1
c
   3	close(10)
      close(11)
	GOTO 6
  10  format(A4,1X,2(A2),2X,F9.7)          ! Lym=a
  80  format(4x,'Not file:',a50)
 100  format(4x,'Error in file: SN_R.dat')
C
   5 	print 100
C
   6	pause ' '
      STOP
	END
c
C--------------------------------------------------------------------------
