c     Indices
C...............................................................................Nov 2021
C SN_R.dat ----------------- daily index data file
CC Ytau27=(1-tau)/(1-tau**n)*(F0+tau*F_1+tau**2*F_2...+tau**29*F_26) =smoothed Index(tau) 
CC Add ranking 27d data starting from min to max
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c .. Input:
c ..    day                           (integer)
c .    month                          (integer)
c .     year                          (integer)
c .     nday - day number of the year (integer)
c
c .  Output:
c .    R27 - integral index of solar activity for 27 days - 1 revolution of the Sun (real)
cc-----------------------------------------------------------------------
      program indices27d1
C produce 27d running indices: F10.7, Lyman-a
C SN_R.dat ----------------- daily index data file
C
 	CHARACTER*64 infile,outfile
	CHARACTER*2 AMN,ADY
	CHARACTER*4 AYEAR,MMDD
	real R27
c
	integer ns, k
      real ssn(0:28)
	+,X1(0:26),X2(0:26)
C      real:: tauR27=0.9623  ! 27 day
C+
C==         infile='Lymady.txt'          ! Lyman-a
C==        outfile='Lyman-27d1.txt'				! Lyman-a
C++         infile='F107d.txt'          ! F10.7
C++        outfile='F107-27d1.txt'	   ! F10.7			
C++	         infile='SSN2d.txt'          ! SSN2
C++	         infile='GECd.txt'          ! GEC
	         infile='SSN1d.txt'          ! SSN1
C++        outfile='SSN2-27d1.txt'	   ! SSN2			
C++        outfile='GEC-27d1.txt'	   ! GEC
      outfile='SSN1-27d1.txt'	   ! SSN1	
	OPEN(11,file=outfile)		   !
C+
c      
      open(unit=10,file=infile,action='READ')   ! +TLG
c	read(10,*) txt
c      
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	tau=0.9623
      tau=exp(-1./26.)
	NS = int(1.0/(1.0-tau))
	nd_inp=0
C
    1	read(10,*,err=5,end=6) iyear,imndy,alpha		 ! Lym-a, F10.7, GEC, SSN1
C    1	read(10,*,err=5,end=6) iyear,imn,idy,ryear,issn,dssn,ik			  !	 SSN2
      call blet4(iyear,AYEAR)
      call blet4(imndy,MMDD)							! Lym-a, F10.7, GEC, SSN1
      AMN=MMDD(1:2)									! Lym-a, F10.7, GEC, SSN1
	ADY=MMDD(3:4)									! Lym-a, F10.7, GEC, SSN1
C	      call blet2(imn,AMN)          ! SSN2
C++	call blet2(idy,ADY)          ! SSN2
C  NEW TLG:
	nd_inp=nd_inp+1
      ssn(0)=alpha		!! Lym-a, F10.7 , GEC, SSN1
C++	ssn(0)=float(issn)  ! SSN2
 	if(nd_inp.eq.NS+1) then
	 goto 2
	    else
C Move data forward by 1 day:
	do k=28,1,-1
	ssn(k)=ssn(k-1)
	enddo
	goto 1
	endif
    2       	fsum=0.
	STAU=1.
      icnv=0 			   
  207 Ftau=0.0
      Rtau=0.0
C
C Rank data from min to max:
      MM=0
      DO N=0,26
      X1(N)=ssn(N)
      ENDDO 
  880 XX=999.0           ! Lyman-a <<1.0	  ; F10.7<999.0  : SSN2<999.0
CREM MIN X1(N)
  890 DO N=0,26
  900 IF (XX.gt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.999.0) GOTO 980
C
  930 DO 960 N=0,26
      IF (X1(N).gt.XX) GOTO 960
      X2(MM)=XX 
	X1(N)=999.0
      MM=MM+1 
  960 CONTINUE      ! N
  970 IF (MM.lt.27) GOTO 880
C
  980      do k=0,26
Crem	fsum=fsum+stau*ssn(k)
	fsum=fsum+stau*X2(k)
	stau=stau*0.9623
      enddo
	coef=(1.-tau)/(1.-stau)
	R27=coef*fsum
c
C	      R27 = (2.0*Rt+Ri)/3.0
	write(*,10) ayear,amn,ady,R27  !    Lym-a, F10.7, GEC, SSN1
	write(11,10) ayear,amn,ady,R27	 ! Lym-a, F10.7, GEC, SSN1
C++	write(*,30) ryear,amn,ady,R27  !    SSN2
C++	write(11,30) ryear,amn,ady,R27	 ! SSN2
      nd_inp=nd_inp-1
C Move data forward by 1 day:
	do k=28,1,-1
	ssn(k)=ssn(k-1)
	enddo
	GOTO 1
c
   3	close(10)
      close(11)
	GOTO 6
C==  10  format(A4,1X,2(A2),2X,F9.7)          ! Lym=a
  10  format(A4,1X,2(A2),2X,F6.2)        !F10.7, GEC
  30  format(F8.3,1X,2(A2),2X,F8.4)        !
  80  format(4x,'Not file:',a50)
 100  format(4x,'Error in file: SN_R.dat')
C
   5 	print 100
C
   6	pause ' '
      STOP
	END
c
C--------------------------------------------------------------------------
