c     Indices
C...............................................................................Nov 2021
C SN_R.dat ----------------- daily index data file
      program indices27d
C produce 27d running indices: F10.7, Lyman-a
C SN_R.dat ----------------- daily index data file
C
 	CHARACTER*64 infile,outfile
	CHARACTER*2 AYR,AMN,ADY
	CHARACTER*4 AYEAR
C 	implicit none
c     .. scalar arguments ..
      integer idayut, monthut, iyearut
C			real UT
C	real Ri, SSN_R12, R27
	real Ri, SSN_R12, RR
c     .. local scalars ..
C      integer ndayut, iUT
      integer ndayut,iny_R			   !++TLG
	      real Rt
c     .. subroutine references ..
c        nnday, indices_R, R_tau 
c
C--	call nnday(idayut,monthut,iyearut,ndayut)
	ndayut=ndoy(iyearut,monthut,idayut)
C++	 case('R27 ')	
      call R_tau(idayut,monthut,iyearut,Ri,Rt) !+TLG
	      R27 = (2.0*Rt+Ri)/3.0
C--			end select

C      iUT = int(UT)
c

	pause ' '
      STOP
	END
c

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c .. Input:
c ..    day                           (integer)
c .    month                          (integer)
c .     year                          (integer)
c .     nday - day number of the year (integer)
c
c .  Output:
c .    Rt - integral index of solar activity for 27 days - 1 revolution of the Sun (real)
c
C      subroutine R_tau(day,month,year,Ri,Rt)
      subroutine R_tau(day,month,year,Ri,Rt)
C	      use Mod_SSN
	implicit none
c     .. scalar arguments ..
      integer day,month,year
      real Ri, Rt
c     .. local scalars ..
C	integer kd, i_R
	integer  i_R
	      integer jd
	integer nday
	integer ns, dyear, irec, nd
	integer w_day,w_month,w_year,nn
	real year_decimal, SD
      real Wsum, Wk, wta, wta0, ww
      real Wsumo
      real:: tauR27=0.964  ! 27 day
	integer issn(0:28),k
        integer iny_R
        integer n_R
	  data n_R/214/
	  character(256) file_R 
	  data file_R/'SN_R.dat'/
c      
C      open(unit=n_R,file=file_R,iostat=kd,
C     *    ACCESS='DIRECT',RECL=38,FORM='FORMATTED',STATUS='OLD')
      open(unit=n_R,file=file_R,action='READ')   ! +TLG
C	      if (kd.ne.0) then
C          print 80, 'SN_R.dat'
C          stop
C      end if
c      
	jd=mod(iny_R-1,4)
	wta0=1.0e-03
	NS = int(1.0/(1-tauR27))
      dyear = year - iny_R
	call nnday(day,month,year,nday)
	irec = dyear*365 + (dyear+jd)/4 + nday
      ww = 1.0
	wta = 1.0
	Wsumo = 0.0
	Wsum = 0.0
C      do nd=0,NS
C	   read(n_R,10,rec=irec,err=5) w_year,w_month,w_day,year_decimal,
C     &                                                       i_R,SD,nn
    1	read(n_R,10,err=5) w_year,w_month,w_day,year_decimal,i_R   ! TLG
     +,SD,nn													   ! TLG
C  NEW TLG:
      issn(0)=i_R
	if ((w_year.eq.year).and.(w_month.eq.month).and.(w_day.eq.day)) 
     +	then
	 goto 2
	    else
C Move data forward by 1 day:
	do k=28,1,-1
	issn(k)=issn(k-1)
	enddo
	goto 1
	endif
    2          do nd=0,NS
C             if (nd.eq.0) Ri=i_R
         if (nd.eq.0) Ri=issn(0)
C	            irec = irec - 1
	Wk=issn(nd+1)
C	         Wk = i_R
	   if (tauR27.le.0.) then
            Rt =  Wk
C-            return
       goto 3
         end if
	   Wsumo = Wsumo + wta
	   if (nd==0) then
	      Wsum = Wsum + Wk
	   else
	      Wsum = Wsum + Wk * wta
	   end if
	   wta = wta * tauR27
      enddo
      Rt = Wsum/Wsumo
   3	close(n_R)
c
      return
c
   5 	print 100
	stop
  10  format(i4,2(1x,i2),1x,f8.3,1x,i4,1x,f5.1,1x,i4)
  80  format(4x,'Not file:',a50)
 100  format(4x,'Error in file: SN_R.dat')
      end subroutine R_tau 
c
C--------------------------------------------------------------------------
