c     Indices
C...............................................................................Nov 2021
C Apply -81d1 averaging => 81st dat
C SN_R.dat ----------------- daily index data file
CC Ytau27=(1-tau)/(1-tau**n)*(F0+tau*F_1+tau**2*F_2...+tau**29*F_26) =smoothed Index(tau) 
CC Add ranking 27d data starting from min to max
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c .. Input:
c ..    day                           (integer)
c .    month                          (integer)
c .     year                          (integer)
c .     nday - day number of the year (integer)
c
c .  Output:
c .    R27 - integral index of solar activity for 27 days - 1 revolution of the Sun (real)
cc-----------------------------------------------------------------------
      program indices81d1
C produce 27d running indices: F10.7, Lyman-a
C SN_R.dat ----------------- daily index data file
C
 	CHARACTER*64 infile,outfile
	CHARACTER*2 AMN,ADY
		CHARACTER*4 MMDD,AYEAR
c
	integer ns, k
      real ssn(0:81)
c	+,X1(0:26),X2(0:26)
C      real:: tauR27=0.9623  ! 27 day
C+
C==         infile='Lymady.txt'          ! Lyman-a
C==        outfile='Lyman-27d1.txt'				! Lyman-a
C++         infile='F107d.txt'          ! F10.7
C++        outfile='F107-27d1.txt'	   ! F10.7			
C--	         infile='SSN2d.txt'          ! SSN2
C--        outfile='SSN2-27d1.txt'	   ! SSN2			
C++        infile='SSN2-27d1.txt'	   ! SSN2			
C++        infile='SSN1-27d1.txt'	   ! SSN1
        infile='F107-27d1.txt'	   ! F107
C++        infile='GEC-27d1.txt'	   !
C++	      outfile='SSN2-81d1.txt'	   ! SSN2			
C++	      outfile='SSN1-81d1.txt'	   ! SSN1			
	      outfile='F107-81d1.txt'	   ! SSN1			
C++	      outfile='GEC-81d1.txt'	   !
	OPEN(11,file=outfile)		   !
C+
c      
      open(unit=10,file=infile,action='READ')   ! +TLG
c	read(10,*) txt
c      
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	tau=0.9623
      tau=exp(-1./26.)
	NS = int(1.0/(1.0-tau))
	nd_inp=0
C
    1	read(10,*,err=5,end=6) iyear,imndy,alpha	  ! Lym-a, F10.7, GEC, SSN1
C    1	read(10,30,err=5,end=6) ryear,amn,ady,R27  !    SSN2(tau)	
      call blet4(iyear,AYEAR)
      call blet4(imndy,MMDD)							! Lym-a, F10.7, GEC, SSN1
      AMN=MMDD(1:2)									! Lym-a, F10.7, GEC, SSN1
	ADY=MMDD(3:4)									! Lym-a, F10.7, GEC, SSN1
C-	      call blet2(imn,AMN)          ! SSN2
C-	call blet2(idy,ADY)          ! SSN2
C  NEW TLG:
	nd_inp=nd_inp+1
      ssn(81)=alpha		!! Lym-a, F10.7, GEC, SSN1
C++	ssn(81)=R27  ! SSN2
 	if(nd_inp.eq.81) then
	 goto 2
	    else
C Move data up by 1 day:
	do k=1,81
	ssn(k-1)=ssn(k)
	enddo
	goto 1
	endif
    2       	fsum=0.
C
  980      do k=1,81
	fsum=fsum+ssn(k)
      enddo
	R81=fsum/81.
c
C	      R27 = (2.0*Rt+Ri)/3.0
	write(*,10) ayear,amn,ady,R81  !    Lym-a, F10.7, GEC, SSN1
	write(11,10) ayear,amn,ady,R81	 ! Lym-a, F10.7, GEC, SSN1
c++	write(*,30) ryear,amn,ady,R81  !    SSN2
c++	write(11,30) ryear,amn,ady,R81	 ! SSN2
      nd_inp=nd_inp-1
C Move data forward by 1 day:
	do k=1,81
	ssn(k-1)=ssn(k)
	enddo
	GOTO 1
c
   3	close(10)
      close(11)
	GOTO 6
C==  10  format(A4,1X,2(A2),2X,F9.7)          ! Lym=a
  10  format(A4,1X,2(A2),2X,F6.2)        !F10.7, GEC
  30  format(F8.3,1X,2(A2),2X,F8.4)        !
  80  format(4x,'Not file:',a50)
 100  format(4x,'Error in file: SN_R.dat')
C
   5 	print 100
C
   6	pause ' '
      STOP
	END
c
C--------------------------------------------------------------------------
