c     Indices
C...............................................................................Jan 2022
C Input ----------------- daily index data file
CC F10A=81 aver centered on given day. 
CC Output: Proxy index: F107A
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c .. Input:
c ..    day                           (integer)
c .    month                          (integer)
c .     year                          (integer)
c .     nday - day number of the year (integer)
c
c .  Output:
c .    R27 - integral index of solar activity for 27 days - 1 revolution of the Sun (real)
cc-----------------------------------------------------------------------
      program indicespd
C
 	CHARACTER*64 infile,outfile
	CHARACTER*2 AMN,ADY,AMNS(0:81),ADYS(0:81)
	CHARACTER*4 AYEAR
	+,MMDD		 ! F10.7, SSN1 (2015...2021)
c
      real ssn(0:81),ryears(0:81)
C+
C==         infile='Lymady.txt'          ! Lyman-a
C==        outfile='Lyman-27d1.txt'				! Lyman-a
        infile='F107d.txt'          ! F10.7
C++         infile='Skpd.txt'          ! Sum kp
C++        outfile='F107-27d1.txt'	   ! F10.7			
C++	         infile='SSN2d.txt'          ! SSN2
C++	         infile='GECd.txt'          ! GEC
C++	         infile='SSN1d1.txt'          ! SSN1(SILSO)
C++	         infile='SSN1d.txt'          ! SSN1
C++        outfile='SSN2-27d1.txt'	   ! SSN2			
        outfile='SSN2p.txt'	   ! SSN2p
C++        outfile='SSN1pd1.txt'	   ! SSN1p ~.SSN1(SILSO)
C++        outfile='SSN1p.txt'	   ! SSN1p 
        outfile='F107p.txt'	   ! F10.7p
C++        outfile='Skppd.txt'	   ! Sum kp

C++        outfile='GEC-27d1.txt'	   ! GEC
C++      outfile='SSN1-27d1.txt'	   ! SSN1	
	OPEN(11,file=outfile)		   !
C+
   90	FORMAT(I4,2I2,2X,F8.3,1X,I3)
c      
      open(unit=10,file=infile,action='READ')   ! +TLG
c	read(10,*) txt
c      
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	nd_inp=0
C
   1	read(10,*,err=5,end=6) iyear,imndy,alpha		 ! Lym-a, F10.7, GEC, SSN1
C++   1	read(10,*,err=5,end=6) iyear,imndy,kps		 ! Sum kp
C>>    1	read(10,*,err=5,end=6) iyear,imn,idy,ryear,issn,dssn,ik			  !	 SSN2
C++    1	read(10,90,err=5,end=6) iyear,imn,idy,ryear,issn			  !	 SSN1(SILSO)
C Add calc Day-of-year+++++++++++++++++++++++++++++++++
       iyr=iyear-iyear/100*100
C++
	imn=imndy/100             ! SSN1 ~ F10.7
	idy=imndy-imn*100		  ! SSN1 ~ F10.7
	lda=ndoy(iyr,imn,idy)
       yr=real(iyr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	dnr=366.
	                          ELSE
	dnr=365.
	ENDIF
        ryear=iyear+(lda-1)/dnr
C END Calc DOY => ryear	++++++++++++++++++++++++++++++
      call blet4(iyear,AYEAR)
      call blet4(imndy,MMDD)							! Lym-a, F10.7, GEC, SSN1
      AMN=MMDD(1:2)									! Lym-a, F10.7, GEC, SSN1
	ADY=MMDD(3:4)									! Lym-a, F10.7, GEC, SSN1
C>>	      call blet2(imn,AMN)          ! SSN2 .SSN1(SILSO)
C>>         call blet2(idy,ADY)          ! SSN2	.SSN1(SILSO)
C  NEW TLG:
	nd_inp=nd_inp+1
      ssn(81)=alpha		!! Lym-a, F10.7 , GEC, SSN1
C++      ssn(81)=kps/80.		! kp-aver daily
C>>      ssn(81)=float(issn)  ! SSN2	.SSN1(SILSO)
	ryears(81)=ryear     ! all
		AMNS(81)=AMN
	ADYS(81)=ADY
 	if(nd_inp.eq.81) then
	 goto 2
	    else
C Move data up by 1 day:
	do k=1,81
	ssn(k-1)=ssn(k)
	ryears(k-1)=ryears(k)
	AMNS(k-1)=AMNS(k)
	ADYS(k-1)=ADYS(k)
	enddo
	goto 1
	endif
    2 CONTINUE
	SUM=0.
	do kk=1,81
	sum=sum+ssn(kk)
	enddo
	SSNA=sum/81.
Cpre	SSNP=(SSNA+ssn(41))/2.
        	SSNP=SSNA
C
C	write(*,10) ayear,amn,ady,R27  !    Lym-a, F10.7, GEC, SSN1
C	write(11,10) ayear,amn,ady,R27	 ! Lym-a, F10.7, GEC, SSN1
	write(*,30) ryears(41),amns(41),adys(41),SSNP  !    SSN2,SSN1,F10.p
	write(11,30) ryears(41),amns(41),adys(41),SSNP ! SSN2,SSN1,F10.p
C
      nd_inp=nd_inp-1
C Move data up by 1 day:
	do k=1,81
	ssn(k-1)=ssn(k)
	ryears(k-1)=ryears(k)
	AMNS(k-1)=AMNS(k)
	ADYS(k-1)=ADYS(k)
	enddo
	GOTO 1
c
   3	close(10)
      close(11)
	GOTO 6
C==  10  format(A4,1X,2(A2),2X,F9.7)          ! Lym=a
  10  format(A4,1X,2(A2),2X,F6.2)        !F10.7, GEC
C  30  format(F8.3,1X,2(A2),2X,F8.4)        !SSN2
C+  30  format(F8.3,1X,2(A2),2X,F6.4)        ! Kp-proxy
  30  format(F8.3,1X,2(A2),2X,F6.2)        ! F10.7
  80  format(4x,'Not file:',a50)
 100  format(4x,'Error in file: SN_R.dat')
C
   5 	print 100
C
   6	pause ' '
      STOP
	END
c
C--------------------------------------------------------------------------
