c     Indices
C...............................................................................Nov 2021
C Input ----------------- daily index data file
CC WU, WL, WE =81 aver centered on given day. // AU, AL, AE
CC Output: Proxy index: WUp=(WUA+WUd)/2. 		// AUp=(AUa+AUd)/2.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c .. Input:
c ..    day                           (integer)
c .    month                          (integer)
c .     year                          (integer)
c .     nday - day number of the year (integer)
c
c .  Output:
c .    R27 - integral index of solar activity for 27 days - 1 revolution of the Sun (real)
cc-----------------------------------------------------------------------
      program indicespd3
C
 	CHARACTER*64 infile,outfile
	CHARACTER*2 AMN,ADY,AMNS(0:81),ADYS(0:81)
	CHARACTER*4 MMDD
c
      real wui(0:81),wli(0:81),wei(0:81),ryears(0:81)
C
C+         infile='wulemd.txt'          ! global
C+         infile='wulesd.txt'          ! south
         infile='wulend.txt'          ! north	 WU, WL. WE
	infile='aualaed.txt'          ! north	AU, AL, AE
C+        outfile='wulempd.txt'	   ! global
C+        outfile='wulespd.txt'	   ! south
C+        outfile='wulenpd.txt'	   ! north 	 WU, WL. WE
        outfile='aualaepd.txt'	   ! north	 AU, AL, AE

	OPEN(11,file=outfile)		   !
C+
c      
      open(unit=10,file=infile,action='READ')   ! +TLG
c	read(10,*) txt
c      
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	nd_inp=0
C
   1	read(10,*,err=5,end=6) ryear,imndy,wu,wl,we		 ! WU, WL, WE
C++    1	read(10,*,err=5,end=6) iyear,imn,idy,ryear,issn,dssn,ik			  !	 SSN2
C Add calc Day-of-year+++++++++++++++++++++++++++++++++
       iyear=int(ryear)
       iyr=iyear-iyear/100*100
	imn=imndy/100
	idy=imndy-imn*100
C END Calc DOY => ryear	++++++++++++++++++++++++++++++
c      call blet4(iyear,AYEAR)
      call blet4(imndy,MMDD)							! Lym-a, F10.7, GEC, SSN1
      AMN=MMDD(1:2)									! Lym-a, F10.7, GEC, SSN1
	ADY=MMDD(3:4)									! Lym-a, F10.7, GEC, SSN1
C++	      call blet2(imn,AMN)          ! SSN2
C++	call blet2(idy,ADY)          ! SSN2
C  NEW TLG:
	nd_inp=nd_inp+1
      wui(81)=wu		!
      wli(81)=wl		!
      wei(81)=we		!
	ryears(81)=ryear     ! all
		AMNS(81)=AMN
	ADYS(81)=ADY
 	if(nd_inp.eq.81) then
	 goto 2
	    else
C Move data up by 1 day:
	do k=1,81
	wui(k-1)=wui(k)
	wli(k-1)=wli(k)
	wei(k-1)=wei(k)
	ryears(k-1)=ryears(k)
	AMNS(k-1)=AMNS(k)
	ADYS(k-1)=ADYS(k)
	enddo
	goto 1
	endif
    2 CONTINUE
	SUMWU=0.
	SUMWL=0.
	SUMWE=0.
	do kk=1,81
	sumwu=sumwu+wui(kk)
	sumwl=sumwl+wli(kk)
	sumwe=sumwe+wei(kk)
	enddo
	SSNAU=sumwu/81.
	SSNAL=sumwl/81.
	SSNAE=sumwe/81.
	SSNWUP=(SSNAU+wui(41))/2.
	SSNWLP=(SSNAL+wli(41))/2.
	SSNWEP=(SSNAE+wei(41))/2.
C
C	write(*,10) ayear,amn,ady,R27  !    Lym-a, F10.7, GEC, SSN1
C	write(11,10) ayear,amn,ady,R27	 ! Lym-a, F10.7, GEC, SSN1
	write(*,30) ryears(41),amns(41),adys(41),SSNAU,SSNAL,SSNAE  !  
	write(11,30) ryears(41),amns(41),adys(41),SSNAU,SSNAL,SSNAE ! 
      nd_inp=nd_inp-1
C Move data up by 1 day:
	do k=1,81
	wui(k-1)=wui(k)
	wli(k-1)=wli(k)
	wei(k-1)=wei(k)
	ryears(k-1)=ryears(k)
	AMNS(k-1)=AMNS(k)
	ADYS(k-1)=ADYS(k)
	enddo
	GOTO 1
c
   3	close(10)
      close(11)
	GOTO 6
C==  10  format(A4,1X,2(A2),2X,F9.7)          ! Lym=a
  10  format(A4,1X,2(A2),2X,F6.2)        !F10.7, GEC
C  30  format(F8.3,1X,2(A2),3(2X,F6.2))        !WU, WL, WE
  30  format(F8.3,1X,2(A2),3(2X,F7.2))        !AU, AL, aE
  80  format(4x,'Not file:',a50)
 100  format(4x,'Error in file: SN_R.dat')
C
   5 	print 100
C
   6	pause ' '
      STOP
	END
c
C--------------------------------------------------------------------------
