      program polyfit2
C.......................................................July 2019
C Polyfit2 for 0,1,...,23 UT of two parameters
C
      dimension x(24),y(24),ynm(24),yhm(24),xi(3),yi(3)
	character*60 infile,outfile,txt
	common /BL1/xi,yi
C
   1  write(*,*) ' Enter name infile or <00> for stop:'
	read(*,*) infile
	if (infile.eq.'00') STOP
C
	outfile='polyfit2.txt'
	OPEN(11,file=infile,action='READ')
	do k=1,8
	read(11,29) txt ! extra lines
	enddo
	OPEN(12,file=outfile,access='APPEND')
C
   29 FORMAT(A60)
   30 FORMAT(75X,F6.1,7X,F7.4,46X,F6.2)
   31 FORMAT(1X,'P1=', 1PE13.6, ' P2=', F7.3, 
     +' P3=', F7.3)
C x=TEC [TECu], yhm=hmF2 [km], ynm=NMF2/10**4
C Limits for fitting results
      xmin=1000.
	xmax=0.
	DO 10 k=1,24
	read(11,30,end=40) yhm(k),ynm(k),x(k)
	IF (xmin.gt.x(k)) xmin=x(k)
      IF (xmax.lt.x(k)) xmax=x(k)
   10	CONTINUE
   40 close(unit=11)
C Prepare for output:
      nxmin=int(xmin/5.0)*5
      nxmax=nint(xmax/5.0)*5
C
C
       nfh=1      ! NmF2
C First NmF2
        do k=1,24
	y(k)=ynm(k)
	enddo
      call subpoly3(nfh,x,y,p1e,p2e,p3e,rmse)
	write(*,*) ' NmF2 vs TEC'
      write(12,*) ' NmF2 vs TEC'	 
	write(*,*) ' p1= ', p1e, ' p2= ', p2e, ' p3=',p3e, ' rms=', rmse
	write(12,*) ' p1= ', p1e, ' p2= ', p2e, ' p3=',p3e, ' rms=', rmse
C
       DO kk=1,3
	write(*,*) xi(kk),yi(kk)
	write(12,*) xi(kk),yi(kk)
	 ENDDO

C Output profile:
	DO jj=nxmin,nxmax,5
	xx=float(jj)
	fx=xx*(p1e*xx+p2e)+p3e
	write(*,*) xx,fx
	write(12,*) xx,fx
	ENDDO

C Second hmF2
       nfh=2      ! hmF2
        do k=1,24
	y(k)=yhm(k)
	enddo
      call subpoly3(nfh,x,y,p1,p2,p3,rms)
	write(*,*) ' hmF2 vs TEC'
      write(12,*) ' hmF2 vs TEC'	 
	write(*,*) ' p1= ', p1, ' p2= ', p2, ' p3=',p3, ' rms=', rms
	write(12,*) ' p1= ', p1, ' p2= ', p2, ' p3=',p3, ' rms=', rms
C
       DO kk=1,3
	write(*,*) xi(kk),yi(kk)
	write(12,*) xi(kk),yi(kk)
	 ENDDO

C
C Output profile:
	DO jj=nxmin,nxmax,5
	xx=float(jj)
	fx=xx*(p1*xx+p2)+p3
	write(*,*) xx,fx
	write(12,*) xx,fx
	ENDDO

C
C  Polyval
C
	pause ' '
	GOTO 1
	END
C=========================================
      subroutine subpoly3(nfh,x,y,p1,p2,p3,rmse)
	dimension x(24),y(24),x1(24),x2(24),y1(24),y2(24) ! X2, Y2 arrays ranked by decreasing order
     +,xi(3),yi(3)
	common /BL1/xi,yi
	nut=24  ! diurnal UT set
C  Median_24:
	MX=0
	MY=0
      DO N=1,nut
      X1(N)=x(N)
	Y1(N)=y(N)
      ENDDO 
C
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,nut
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
	ENDDO       !N
  920 IF (XX.eq.0) GOTO 980
C
C
  930 DO 960 N=1,nut
      IF (X1(N).lt.XX) GOTO 960
      MX=MX+1 
      X2(MX)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MX.lt.NUT) GOTO 880
  980 XMM=FLOAT(MX)
      XD1=XMM/2.
      NXD1=INT(XD1)
	CXD1=FLOAT(NXD1) 
      NXD2=NXD1+1 
      IF (CXD1.LT.XD1) THEN 
	XMD=X2(NXD2)
	else
	XMD=(X2(NXD1)+X2(NXD2))/2.
	ENDIF
C
C
  881 YY=0.
CREM MAX Y1(N)
  891 DO N=1,nut
  901 IF (YY.lt.Y1(N)) THEN 
      YY=Y1(N)
	ENDIF
	ENDDO       !N
  921 IF (YY.eq.0) GOTO 981
C
C
  931 DO 961 N=1,nut
      IF (Y1(N).lt.YY) GOTO 961
      MY=MY+1 
      Y2(MY)=YY 
	Y1(N)=0.
  961 CONTINUE      ! N
  971 IF (MY.lt.NUT) GOTO 881
  981 YMM=FLOAT(MY)
      YD1=YMM/2.
      NYD1=INT(YD1)
	CYD1=FLOAT(NYD1) 
      NYD2=NYD1+1 
      IF (CYD1.LT.YD1) THEN 
	YMD=Y2(NYD2)
	else
	YMD=(Y2(NYD1)+Y2(NYD2))/2.
	ENDIF
C
      XX1=X2(nut)
      XX2=XMD
	XX3=X2(1)
	YY2=YMD
C
	IF (nfh.eq.1) THEN
	YY1=Y2(nut)            !  NmF2min
	YY3=Y2(1)			   !  NmF2max
      	DO N=1,nut
      	IF (abs(x(N)-XX3).LT.0.1) THEN
Crem	YY3=y(N)			   ! NmF2 (TECmax)
      	YY3=(y(N)+YY3)/2.		   ! [NmF2(TECmax)+Nmax]/2.
      	exit
      	ENDIF
      	ENDDO 
	              ELSE
	YY1=Y2(1)		       ! hmF2max
	YY3=Y2(nut)			   ! hmF2min
      	DO N=1,nut
      	IF (abs(x(N)-XX3).LT.0.1) THEN
C++      	IF (abs(x(N)-XX1).LT.0.1) THEN
	YY3=y(N)				! hmF2 (TECmax)
C++	YY1=(y(N)+YY1)/2.			! [hmF2(TECmax)+hmax]/2.
      	exit
      	ENDIF
      	ENDDO 
	              ENDIF
C
C polyfit2 coefficients
      dx21=xx2-xx1
      dx32=xx3-xx2
	dy21=yy2-yy1
	dres=dx21*dx32*(xx3-xx1)
	p1=((yy3-yy2)*dx21-dy21*dx32)/dres
	p2=dy21/dx21-p1*(xx2+xx1)
	p3=yy2-xx2*(p1*xx2+p2)
C RMSE
      sum=0.
	DO N=1,nut
	del=y(N)-x(N)*(p1*x(N)+p2)+p3
	sum=sum+del**2
	ENDDO
	rmse=sqrt(sum/nut)
C
C Selected points:
       xi(1)=XX1
       xi(2)=XX2
       xi(3)=XX3
       yi(1)=YY1
       yi(2)=YY2
       yi(3)=YY3
	RETURN
	END
C

