      subroutine polyfit45d(AYR,AMN,ADY,x,y,p1,p2,p3,rmse)
C.......................................................Jan. 2022
C SSN2 or F107 for -45 days n=1,2,...,45
C.......................................................Aug 2019
C Polyfit2 for 0,1,...,23 UT of two parameters for 80 stations
C Apply least-squire fit to 2nd order polynomial to produce p1,p2,p3
C
      dimension x(45),y(45),ynm(45),yfm(45),yhm(45)
     +,ires(45)
C	+,IM(12)
	character*128 infilef,infileh,infilet,outfilef,outfileh,txt              ! Aug 2019
	+,outpolyf,outpolyh
      CHARACTER*2 ST,STS(80),AYR,AMN,ADY,Cf(24),Ch(24),CC			   ! AUG 2019
	CHARACTER*6 YYMMDD
	CHARACTER*1 C
C	      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C	common /BL1/xi,yi
C
C
C
   29 FORMAT(A128)
   30 FORMAT(A6,2X,24(F3.1,A2)) ! foF2 input
   31 FORMAT(1X,'P1=', 1PE13.6, ' P2=', F7.3, 
     +' P3=', F7.3)
   32 FORMAT(A6,2X,24(F3.0,A2)) ! hmF2
   33 FORMAT(A6,1X,24(F4.1,1X)) ! TEC
C
C First 
      call subpoly45(x,y,p1f,p2f,p3f,rmse)
C-	write(*,*) ' NmF2 vs TEC'
C+      write(11,*) ' NmF2 vs TEC'	 
	write(*,*) YYMMDD,' p1= ',p1f,' p2= ',p2f,' p3=',p3f,' rms=',rmse
C	write(13,*) YYMMDD, p1f, p2f, p3f
C
C Output profile:
	DO jj=1,45
	xx=x(jj)  !TEC
	fnm=xx*(p1f*xx+p2f)+p3f  ! Polyval
	if (fnm.lt.4.) fnm=ynm(k)
	CC=Cf(jj)
	C=CC(1:1)
	IF ((C.eq.'/').or.(C.eq.'_')) THEN
      yfm(jj)=sqrt(fnm/1.24)
	CC(1:1)='_'
	Cf(jj)=CC
	endif
        ires(jj)=nint(yfm(jj)*10.)
	ENDDO
	write(*,34) YYMMDD,(ires(k),Cf(k),k=1,24)
	write(15,34) YYMMDD,(ires(k),Cf(k),k=1,24)
C
   34 FORMAT(A6,2X,24(I3,A2)) ! foF2 out
C
C Second hmF2
        do k=1,24
	y(k)=yhm(k)
	enddo
      call subpoly3c(x,y,p1h,p2h,p3h,rms)
	write(*,*) ' hmF2 vs TEC'
C+    write(12,*) ' hmF2 vs TEC'	 
	write(*,*) YYMMDD,' p1= ',p1h,'p2= ',p2h,' p3=',p3h,' rms=', rms
	write(14,*) YYMMDD, p1h, p2h, p3h
C
C
C Output profile:
	DO jj=1,24
	xx=x(jj)  !TEC
	hp=xx*(p1h*xx+p2h)+p3h  ! Polyval hmF2
	if ((hp.lt.175.).or.(hp.gt.500.)) hp=yhm(k)
	CC=Ch(jj)
	C=CC(1:1)
	IF ((C.eq.'/').or.(C.eq.'_')) THEN
      yhm(jj)=hp
	CC(1:1)='_'
	Ch(jj)=CC
	endif
        ires(jj)=nint(yhm(jj))
	ENDDO
	write(*,34) YYMMDD,(ires(k),Ch(k),k=1,24)
	write(16,34) YYMMDD,(ires(k),Ch(k),k=1,24)
  123	CONTINUE  ! day-to-day cycle
   40 close(unit=10)
   41 close(unit=11)
   42 close(unit=12)
      close(unit=13)
	close(unit=14)
      close(unit=15)
	close(unit=16)
 1234	CONTINUE  ! station cycle
C
C
	pause ' '
       STOP
	END
C=========================================
      subroutine subpoly45(x,y,p1,p2,p3,rmse)
	dimension x(45),y(45) 
	nut=45  ! 45d indices
C  
	s0=45.
	s1=0.
	s2=0.
	s3=0.
	s4=0.
	syx2=0.
	syx=0.
	sy=0.
      DO N=1,nut
	x1=x(N)
	x2=x1*x1
	x3=x1*x2
	x4=x2*x2
	y1=y(N)
	yx=y1*x1
	yx2=y1*x2
	s1=s1+x1
	s2=s2+x2
	s3=s3+x3
	s4=s4+x4
	syx2=syx2+yx2
	syx=syx+yx
	sy=sy+y1
      ENDDO 
C
      d1=(s0*s3-s1*s2)
      c1=(s0*s4-s2*s2)/d1
      c2=(s0*syx2-sy*s2)/d1
	d2=(s0*s2-s1*s1)
      c3=(s0*s3-s1*s2)/d2
      c4=(s0*syx-sy*s1)/d2

C
C p1=a; p2=b; p3=c
C
C polyfit2 coefficients
	p1=(c2-c4)/(c1-c3)
	p2=c2-p1*c1
	p3=(sy-p1*s2-p2*s1)/s0
C RMSE
      sum=0.
	DO N=1,nut
	del=y(N)-(x(N)*(p1*x(N)+p2)+p3)
	sum=sum+del**2
	ENDDO
	rmse=sqrt(sum/nut)
C
	RETURN
	END
C

