      program polyfit8c
C.......................................................Aug. 2019
C Apply least-squire fit to 2nd order polynomial to produce p1,p2,p3
C
C Polyfit2 for 0,1,...,23 UT of two parameters for 8 stations GNSS   
C
      dimension x(24),y(24),ynm(24),yhm(24)
	character*60 infile,outfilef,outfileh,txt              ! July 2019
      CHARACTER*2 AYR,AMN			   ! July 2019
	CHARACTER*4 ST,STS(8)			   ! Aug 2019
       DATA STS/
     + 'adis','cztg','kiru','mobn','nico','sutm','syog','zamb'/     ! Aug 2019

      infile='teststat_1.out'                                    ! July 2019
C	outfilef='polyymmfc.txt'   ! My least squire-err?
C	outfileh='polyymmhc.txt'   ! My least squire-err?
	outfilef='polyymmfm.txt'   ! Mathlab polyfit2
	outfileh='polyymmhm.txt'   ! Mathlab polyfit2
      WRITE(*,*) ' ENTER JYR and JMN FOR OUTPUT FILE='  ! July 2019
      READ(*,*) JYR,JMN                                ! July 2019
      
Ctemp	JYR=19		 ! temp
Ctemp	JMN=7		 ! temp
	call blet2(jyr,AYR)
	call blet2(jmn,AMN)
	outfilef(4:5)=AYR
	outfileh(4:5)=AYR
	outfilef(6:7)=AMN
      outfileh(6:7)=AMN
	OPEN(11,file=outfilef)
	OPEN(12,file=outfileh)

   1  DO 1234 ist=1,8
C/      write(*,*) ' Enter name infile or <00> for stop:'
C/	read(*,*) infile
C/	if (infile.eq.'00') STOP
C
       st=sts(ist)                                  ! July 2019
	infile(5:8)=st								  ! July 2019
C
	OPEN(10,file=infile,action='READ')
	read(10,29) txt ! extra line
	write(*,29) txt
C+	write(11,29) txt
C+	write(12,29) txt
C
   29 FORMAT(A60)
   30 FORMAT(75X,F6.1,7X,F7.4,46X,F6.2)
   31 FORMAT(1X,'P1=', 1PE13.6, ' P2=', F7.3, 
     +' P3=', F7.3)
C x=TEC [TECu], yhm=hmF2 [km], ynm=NMF2/10**4
C Limits for fitting results
      xmin=1000.
	xmax=0.
	DO 10 k=1,24
	read(10,30,end=40) yhm(k),ynm(k),x(k)
	IF (xmin.gt.x(k)) xmin=x(k)
      IF (xmax.lt.x(k)) xmax=x(k)
   10	CONTINUE
   40 close(unit=10)
C Prepare for output:
      nxmin=int(xmin/5.0)*5
      nxmax=nint(xmax/5.0)*5
C
C
C First NmF2
        do k=1,24
	y(k)=ynm(k)
	enddo
      call subpoly3c(x,y,p1e,p2e,p3e,rmse)
	write(*,*) ' NmF2 vs TEC'
C+      write(11,*) ' NmF2 vs TEC'	 
	write(*,*) st,' p1= ', p1e, ' p2= ', p2e, ' p3=',p3e, ' rms=',rmse
	write(11,*) st, p1e, p2e, p3e
C

C Output profile:
	DO jj=nxmin,nxmax,5
	xx=float(jj)
	fx=xx*(p1e*xx+p2e)+p3e
	write(*,*) xx,fx
C+	write(11,*) xx,fx
	ENDDO

C Second hmF2
        do k=1,24
	y(k)=yhm(k)
	enddo
      call subpoly3c(x,y,p1,p2,p3,rmse)
	write(*,*) ' hmF2 vs TEC'
C+    write(12,*) ' hmF2 vs TEC'	 
	write(*,*) st,' p1= ', p1, ' p2= ', p2, ' p3=',p3, ' rms=', rmse
	write(12,*) st, p1, p2, p3
C

C
C Output profile:
	DO jj=nxmin,nxmax,5
	xx=float(jj)
	fx=xx*(p1*xx+p2)+p3
	write(*,*) xx,fx
C+	write(12,*) xx,fx
	ENDDO
 1234	CONTINUE
      close(unit=11)
	close(unit=12)
C
C  Polyval
C
	pause ' '
C+	GOTO 1
	END
C=========================================
      subroutine subpoly3c(x,y,p1,p2,p3,rmse)
	dimension x(24),y(24) 
	nut=24  ! diurnal UT set
C  
	s0=24.
	s1=0.
	s2=0.
	s3=0.
	s4=0.
	syx2=0.
	syx=0.
	sy=0.
      DO N=1,nut
	x1=x(N)
	x2=x1*x1
	x3=x1*x2
	x4=x2*x2
	y1=y(N)
	yx=y1*x1
	yx2=y1*x2
	s1=s1+x1
	s2=s2+x2
	s3=s3+x3
	s4=s4+x4
	syx2=syx2+yx2
	syx=syx+yx
	sy=sy+y1
      ENDDO 
C
      d1=(s0*s3-s1*s2)
      c1=(s0*s4-s2*s2)/d1
      c2=(s0*syx2-sy*s2)/d1
	d2=(s0*s2-s1*s1)
      c3=(s0*s3-s1*s2)/d2
      c4=(s0*syx-sy*s1)/d2

C
C p1=a; p2=b; p3=c
C
C polyfit2 coefficients
	p1=(c2-c4)/(c1-c3)
	p2=c2-p1*c1
	p3=(sy-p1*s2-p2*s1)/s0
C RMSE
      sum=0.
	DO N=1,nut
	del=y(N)-(x(N)*(p1*x(N)+p2)+p3)
	sum=sum+del**2
	ENDDO
	rmse=sqrt(sum/nut)
C
	RETURN
	END
C

