c     Indices
C...............................................................................Nov 2021
C Add production of daily proxy SSN1, COV <=== -81d(-27d_tau) 
c .    R27 - integral index of solar activity for 27 days - 1 revolution of the Sun
C produce -81d(-27d_tau) running indices: SSN1p, F10.7p
C Input:  d:\web\graf\kpYEAR ----------------- daily index data file
C Output:  'd:\web\graf\ssncov.txt'----------------- 0:108 recent days	 YEAR MN DY ssnd ssn27 ssn81 covd cov27 cov81
C
C Apply -81d1 averaging => 81st dat
C 
CC Ytau27=(1-tau)/(1-tau**n)*(F0+tau*F_1+tau**2*F_2...+tau**29*F_26) =smoothed Index(tau) 
CC Add ranking 27d data starting from min to max
cc-----------------------------------------------------------------------
      program solind
C
 	CHARACTER*64 infilekp,outfile,indate
	CHARACTER*2 AMN,ADY,DD2,AMN_pre,ADY_pre,BMN.BDY
	CHARACTER*4 AYEAR,AYEAR_pre,BYEAR
      REAL rzi(0:109),cvi(0:109),IM(12),rz(0:2),cv(0:2)
	+,rz27(0:109),cv27(0:109),rz81(0:109),cv81(0:109)
	+,X1R(0:26),X2R(0:26),X1C(0:26),X2C(0:26)
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C	tau=0.9623
      tau=exp(-1./26.)
	NS = int(1.0/(1.0-tau))
C
      infilekp='d:\web\graf\kpYEAR'	   ! Tamara
	      outfile='d:\web\graf\ssncov.txt'	   ! Tamara
C
   99	format(A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,I3))		
   10 FORMAT(3I2,56X,F3.0,F6.2)   

	indate='d:/web/graf/date'    !!! Tamara !!!!!!!
C=	indate='/var/www/izmiran/ionosphere/weather/graf/date' !!! LIUBA !!!!!!!
C
	open(10,file=indate)
	read(10,99) AYEAR,AMN,DD2,AYEAR_pre,AMN_pre,ADY_pre,ldaend,lda_pre	  !MAR2020
C	WRITE(*,*) 'YEAR, AMN, DD2 = ',AYEAR, AMN, DD2,AYEAR_pre,AMN_pre
C	+,ADY_pre,ldaend,lda_pre														  !MAR2020
	AYR=YEAR(3:4)
	close(unit=10)													  !+
C
	read(AYR,*) xyr
	iyr=int(xyr)
	read(amn,*) xmn
	imn=int(xmn)
 	read(dd2,*) dend
	idy=int(dend)				  !JULY 2020
	idend=idy
C
      IF(iyr/4*4.eq.iyr) THEN
               IM(2)=29
					idnr=366
        ELSE
                IM(2)=28
	  	idnr=365
	       ENDIF
C
      AYR_pre=YEAR_pre(3:4)
	read(AYR_pre,*) ryr_pre
	iyr_pre=int(ryr_pre)

	read(AMN_pre,*) xmn_pre   !Apr2020
	imn_pre=int(xmn_pre)	  !Apr2020

	read(ADY_pre,*) xdy_pre   !Apr2020
	idy_pre=int(xdy_pre)	  !Apr2020
C
      	do k=0,108
	rzi(k)=0.0
	cvi(k)=0.0
	enddo
C
	ipre=0
	if (ldaend.lt.109) then
	  ipre=1
	endif
C
	if (ipre.eq.0) GOTO 203  ! avoid reading preceding year file >>>>>>>>>>>>>>>>>>
C
C For Preceding year:
	infilekp(15:18)=AYEAR_pre  !!! Tamara
C=									  !+ Ljuba

	OPEN(13,FILE=infilekp,action='READ')  
  201 continue
	READ(13,10,END=202) BYR,BMN,BDY,rz(0),cv(0)
  198	if (cov(0).lt.50.) then
	cov(0)=63.8255+0.8868*irz(0)
	endif
		rzi(109)=rz(0))
 	cvi(109)=cv(0)
	icnt=icnt+1
	ipcnt=ipcnt+1
	 rz(2)=rz(1)
	rz(1)=rz(0)
	cv(2)=cv(1)
	cv(1)=cv(0)
C
C Move data 1 line up:
	do k=1,109
	rzi(k-1)=rzi(k)
	cvi(k-1)=cvi(k)
	enddo
	if (ipcnt.eq.108) ipcnt=ipcnt-1
	 GOTO 201
  202	close(unit=13)
C
C For current year:
  203	infilekp(15:18)=YEAR   !!! Tamara
C=   	infilekp(44:47)=YEAR 	 !!! LIUBA ????????
C	WRITE(*,*) 'infilekp = ',infilekp
C
   30	FORMAT(A4,2(1X,A2),6(1X,F6.2))
C Start reading previos data from OUTFILE:
	OPEN(12,file=outfile)		   !SSN, COV
       do kk=0,107
	read(12,30,end=51) BYEAR,BMN,BDY,rzi(kk),rz27(kk),rz81(kk)
	+,cvi(kk),cv27(kk),cv81(kk) 
	 enddo
   51	close(unit=12)
C
		OPEN(13,FILE=infilekp,action='READ')
	OPEN(12,file=outfile,access='APPEND')		   !SSN, COV
C      
  204 continue  
		do i=1,3
 	cv(i-1)=cv(i)
	rz(i-1)=rz(i)
	enddo

	 READ(13,10,err=139,END=205) KYR,KMN,KDY,rz(0),cv(0)
       klda=ndoy(kyr,kmn,kdy)		 !APR 2020
	call blet2(kyr,BYR)          !APR 2020
	call blet2(kmn,BMN)          !APR 2020
	call blet2(kdy,BDY)          !APR 2020
c      
	IF ((KYR.eq.IYR).and.(klda.eq.ldaend)) THEN
	goto 207    !Apr 2020 ?????????????????
	ENDIF
	goto 138										   
  139	write(*,*) 'No k-index file'
	pause ' '    !!! Ljuba
      stop
  138	if ((iflag.eq.0).and.(klda.eq.lda_pre)) then	 !APR 2020
	 iflag=1
	goto 140
	endif
	if (iflag.eq.1) then
	iflag=2
       endif
  140	rzi(108)=rz(0)
 	cvi(108)=cv(0)
	 rz(2)=rz(1)
	rz(1)=rz(0)
	cv(2)=cv(1)
	cv(1)=cv(0)
C Move data 1 line up:
	do k=1,108
	rzi(k-1)=rzi(k)
	cvi(k-1)=cvi(k)
	enddo
C
	icnt=icnt+1
	ipcnt=ipcnt+1
	if (iflag.eq.2) goto 207
       	ipreday=kdy						 !APR 2020
       	iyr_inp=kyr                      !APR 2020
      imn_inp=kmn                          !APR 2020  
      lda_ipreday=klda                     !APR 2020
	if (lda_ipreday.le.lda_pre) then		! APR 2020
        if (lda_ipreday.eq.lda_pre) then	   ! APR 2020
	rz(0)=rzi(108)				 ! APR 2020
	cv(0)=cvi(108)					 ! APR 2020
C
       if (lda_ipreday.lt.lda_pre) GOTO 204                       ! Apr 2020
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Update -27d value
C
C Rank data from min to max:                       
  207	nd=0
      do k=108,82,-1
	X1R(nd)=rzi(k)
      X1C(nd)=cvi(k)
	nd=nd+1
	enddo
C++
      MM=0
  880 XXS=999.0           ! SSN<999.0
CREM MIN X1S(N)
  890 DO N=0,26
  900 IF (XXS.gt.X1S(N)) THEN 
      XXS=X1S(N)
	ENDIF
      ENDDO      !N
  920 IF (XXS.eq.999.0) GOTO 980
C
  930 DO 960 N=0,26
      IF (X1S(N).gt.XXS) GOTO 960
      X2S(MM)=XXS 
	X1S(N)=999.0
      MM=MM+1 
  960 CONTINUE      ! N
  970 IF (MM.lt.27) GOTO 880
C
  980      do k=0,26
Crem	fsum=fsum+stau*ssn(k)
	fsum=fsum+stau*X2S(k)
	stau=stau*0.9623
      enddo
	coef=(1.-tau)/(1.-stau)
	R27S=coef*fsum
	rz27(108)=R27S
c
      MM=0
  881 XXC=999.0           ! F10.7<999.0  
CREM MIN X1(N)
  891 DO N=0,26
  901 IF (XXC.gt.X1C(N)) THEN 
      XXC=X1C(N)
	ENDIF
      ENDDO      !N
  921 IF (XXC.eq.999.0) GOTO 981
C
  931 DO 961 N=0,26
      IF (X1C(N).gt.XXC) GOTO 961
      X2C(MM)=XXC 
	X1C(N)=999.0
      MM=MM+1 
  961 CONTINUE      ! N
  971 IF (MM.lt.27) GOTO 881
C
  981      do k=0,26
Crem	fsum=fsum+stau*ssn(k)
	fsum=fsum+stau*X2C(k)
	stau=stau*0.9623
      enddo
	coef=(1.-tau)/(1.-stau)
	R27C=coef*fsum
	cv27(108)=R27C
c
C
C  NEW TLG:
    2       	fsum=0.
            	rsum=0.
C
  980      do k=27,108
	fsum=fsum+cv27(k)
	rsum=rsum+sn27(k)
      enddo
	R81=rsum/81.
	F81=fsum/81.
	rz81(108)=R81
	cv81(108)=F81
	kk=108
	write(*,30) ayear,amn,ady,BYEAR,BMN,BDY,rzi(kk),rz27(kk),rz81(kk)
 	+,cvi(kk),cv27(kk),cv81(kk) !    SSN, F10.7
	write(11,30) ayear,amn,ady,BYEAR,BMN,BDY,rzi(kk),rz27(kk),rz81(kk)
  	+,cvi(kk),cv27(kk),cv81(kk) !    SSN, F10.7
C Move data forward by 1 day:
C?	do k=1,108
C?	ssn(k-1)=ssn(k)
C?	enddo
C?	GOTO 1
c
   3	close(11)
	GOTO 6
C==  10  format(A4,1X,2(A2),2X,F9.7)          ! Lym=a
c  10  format(A4,1X,2(A2),2X,F6.2)        !F10.7
  30  format(F8.3,1X,2(A2),2X,F8.4)        !
  80  format(4x,'Not file:',a50)
 100  format(4x,'Error in file: SN_R.dat')
C
   5 	print 100
C
   6	pause ' '
      STOP
	END
c
C--------------------------------------------------------------------------
