C*************************************************************   
CC 
      SUBROUTINE SUBAPFp3(IYYYY,IMN,IDY,Fp3,Rp3)
CC-------------------------------------------------------------------
CC......................................................Oct. 2017
CC Proxy3=(_81d+_27d+_3d)/3 =smoothed SSN1 and F10.7 index
CC
CC T.L. Gulyaeva........................................May. 2017 
C
CC Source: former IRI-Plas subroutine: 
CC        SUBROUTINE APF(IYYYY,IMN,ID,HOUR,IAP,F81,R81)
CC Modified to produce sunspot number R81, and solar radio flux F81 
CC from two successive kpYEAR annual files
CC Input: 
CC       kpYEAR  (preceding year: IYYYY-1)                              
CC       kpYEAR  (given year: IYYYY)                              
c--------------------------------------------------------------------
c 
c T.L. Gulyaeva ......................................  Sep. 2001. 
c Modified for producing solar radio flux F10.7, F81, averaged for
c 81 days preceeding given day
C 
C------------------------------------------------------------------------
      DIMENSION lm(12),icurkp(0:7),iap0(8)
     &,icv(82),irz(82),CC(81)
      CHARACTER*4 YEAR,YEAR_pre
      CHARACTER*80 infilekp
      COMMON /FIKP1/iyear_cur,imn_cur,idy_cur
	COMMON /BL1/CC,SMED,SMIN,SMAX
      DATA LM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C START: 
      ipcnt=0 ! keep cnt -82,...,-1

         do k=1,82
       irz(k)=0
       icv(k)=0
         enddo

C   Input file kpYEAR starts from 1948:
      if((iyyyy.lt.1948).or.(iyyyy.gt.iyear_cur)) goto 21 !*
      IF ((iyyyy.eq.iyear_cur).and.(imn.gt.imn_cur)) goto 21 !*
      IF ((iyyyy.eq.iyear_cur).and.(imn.eq.imn_cur).and.    !*
     *   (idy.gt.idy_cur)) goto 21 !*TEST
C
        iy=iyyyy-1900

 770       z1=iy/4.0
        lm(2)=28
           if(iyyyy/4*4.eq.iyyyy) lm(2)=29
      if (iy.ge.100) then
      iyr=iy-100
      else
      iyr=iy
      endif
      call blet4(iyyyy,YEAR)
      iYYYY_pre=iYYYY-1
      call blet4(iYYYY_pre,YEAR_pre)
C
      idend=idy
C
C Day-of-year:
      ldaend=ndoy(iyyyy,imn,idend)       ! current day-of-year
C
      ipre=0
       if (ldaend.lt.81) then
        ipre=1    ! Include data for preceding year
       endif
C
      infilekp='kpYEAR'  
C
10    FORMAT(3I2,6X,8(I2),3X,8(I3),7X,I3,I3,1X,I1)

C
C-------------------------------------------------------------------------------
C Go to read current year file kpYEAR (avoid preceding year input) if current day IDY>81 day-of-year:
C
      if (ipre.eq.0) GOTO 203 !avoid input of preceding year file kpYEAR>>>>>
C
C-------------------------------------------------------------------------------
C Include Input file 'kpYEAR' for preceding year 
C
      infilekp(3:6)=YEAR_pre  !!! Tamara

      OPEN(13,FILE=infilekp,STATUS='OLD',ERR=21)  
  201 continue

      READ(13,10,END=202) JYR,JMN,JDY,(icurkp(k),k=0,7)
     &,(iap0(i),i=1,8),ir1,if1,if2
C
C Replace missed F10.7 by regression model:
      if (if1.eq.0) then
      cov=63.8255+0.8868*ir1  ! daily F10.7(Rz) model
      icv(82)=nint(cov*10.)
      else
      icv(82)=if1*10+if2  !F107*10
      endif
      irz(82)=ir1
C Move data 1 line up:
      do k=1,81
      irz(k)=irz(k+1)
      icv(k)=icv(k+1)
      enddo
      GOTO 201
  202 close(unit=13)
      ipcnt=81-ldaend   ! 
C
C For current year:
  203 infilekp(3:6)=YEAR   !
C
      OPEN(13,FILE=infilekp,ERR=21)
C
C Read file kpyear for current year:
C
  204 continue  
C
      READ(13,10,err=29,END=30) JYR,JMN,JDY,(icurkp(k),k=0,7)
     &,(iap0(i),i=1,8),ir1,if1,if2
      irz(82)=ir1
      if (if1.eq.0) then
       cov=63.8255+0.8868*ir1  ! daily F10.7(Rz) model
       icv(82)=nint(cov*10.)
      else
       icv(82)=if1*10+if2  !F107*10
      endif
C Move data 1 line up:
  140 do  k=1,81
      irz(k)=irz(k+1)
      icv(k)=icv(k+1)
      enddo
C
      ipcnt=ipcnt+1

      if (ipcnt.lt.81) goto 204

      IF ((JYR.eq.IYR).and.(JMN.eq.IMN).and.(JDY.eq.idend)) then 
      goto 207
      ELSE
      ipcnt=ipcnt-1
      goto 204
      ENDIF

C data for 81 preceding days are collected                       
  207 Fp3=0.0
      Rp3=0.0
      icnv=0
      do k=1,81
       CC(k)=float(irz(k))
	enddo
	call submedp3	! CMED
	Rp3=SMED
C
      do k=1,81
       CC(k)=icv(k)/10.
	enddo
	call submedp3	! CMED
	      Fp3=SMED
C
C
      goto 30
21      write(*,100)
100     format(1X,'Date is outside range of Kp-Ap indices file.')
      goto 30
  29  write(*,*) 'Error in input k-index file',infilekp 
C      pause ' '
      stop
  30  CLOSE(unit=13)
      RETURN
      END

C __________________________________________________________________________
C
