      subroutine subinterp1x1(glat,glon,syr,smn,sdy,sut,res)
C.................................................................Aug. 2019
C Gulyaeva Tamara <gulyaeva@izmiran.ru>
C
C Subroutine to interpolate data from IONEX maps (foF2, hmF2, TEC)
C Input : fm='f' means foF2
C		fm='h' means hmF2
C		fm='t' means TEC
C         glat - geographic latitute
C         glon - geographic longitude
C         syr - YEAR = '99' for 1999,'00' for 2000, etc.
C         smn - month
C         sdy - day of month
C         sut - hour, UT
C.................................................................
C Outpur : res - value of foF2 (0.1 MHz), hmF2 (km), or TEC (0.1TECU)
C 
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Use fc,hc,tc interpolated from directories dfc, dhc, dtc maps - update addresses for input file
C
	DIMENSION fhdat(360,180)	  ! maps TEC 1x1 glong,glat
	CHARACTER*1 fm
	CHARACTER*2 syr,smn,sdy,sut
c-	CHARACTER(10) DDDD
c-	CHARACTER*4 TIMC 
c-	CHARACTER(5) ZZZ
      CHARACTER*45 infilet
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Use fc,hc predictions from directories dfs, dhs
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	fm='t'   ! TEC
	read(syr,*) ryr
	iyr=int(ryr)
	read(sdy,*) rdy1
	 ndy1=int(rdy1)
	read(smn,*) rmn1
	imn1=int(rmn1)
C Use fc,hc predictions from directories dfc or dhc
		if (fm.ne.'m') then  ! TEC median
C	infilef='d:\web\graf\dfc\YR\MN\ut\fcMNDDUT.jYR' ! path and name of input file JPL
      infilet='d:\UTEC\20YR\MN\tiMNDDUT00.jYR' !path\name of JPLI TEC 1x1 maps  only 0, 1,...,23 UT
	infilet(11:12)=SYR
	infilet(29:30)=SYR
	infilet(14:15)=SMN
	infilet(19:20)=SMN
	infilet(21:22)=sdy
	infilet(23:24)=sut
	else
	infilet='d:\web\dts\YR\MN\tcMN00UT.mYR' ! path and name of input median file JPL
	infilet(12:13)=SYR
	infilet(15:16)=SMN
	infilet(28:29)=SYR
	infilet(20:21)=SMN
	infilet(24:25)=sut
	endif
 204	format(360(1X,F4.0))
C
	OPEN(10,FILE=INFILET,action='READ')		

		do ilat=1,180
	read(10,204) (fhdat(k,ilat),k=1,360)	
	enddo
	close(unit=10)
C
C      interpolate for glat,glon
C Linear Interpolation   
	aglat=-90.5
	res=0.
	res11=0.
	res12=0.
	res21=0.
	res22=0.
	do 161 ilat=1,179 ! select pair of lats-lines (k) & (k+1)
c	aglat=-89.5,-88.5,...,89.5
	aglat=aglat+1.0
	aglat2=aglat+1.0
C
	if ((glat.ge.aglat).and.(glat.le.aglat2)) then  !   <<<<1
C Select pair of longs embracing glong
	 clon=-180.5
	along=glon
	do j=1,359 ! select pair of longs (j) & (j+1)
	clon=clon+1.0
	clon2=clon+1.0
	if (along.eq.-180.) then
	res11=fhdat(1,ilat)
	res12=fhdat(2,ilat)
	res21=fhdat(1,ilat+1)
	res22=fhdat(2,ilat+1)
C=	res1=res11+(res12-res11)*(along-clon)
      res1=res11+(res21-res11)*(glat-aglat)
C=	res2=res21+(res22-res21)*(along-clon)
       res2=res12+(res22-res12)*(glat-aglat)
C=	res=res1+(res2-res1)*(glat-aglat)
       res=res1+(res2-res1)*(along-clon)
	exit
	endif
C
	if ((along.eq.180.).and.(clon.gt.178.)) then
	res11=fhdat(359,ilat)
	res12=fhdat(360,ilat)
	res21=fhdat(359,ilat+1)
	res22=fhdat(360,ilat+1)
c=	res1=res11+(res12-res11)*(along-clon)
      res1=res11+(res21-res11)*(glat-aglat)
c=	res2=res21+(res22-res21)*(along-clon)
       res2=res12+(res22-res12)*(glat-aglat)
c=	res=res1+(res2-res1)*(glat-aglat)
       res=res1+(res2-res1)*(along-clon)
	exit
	endif
C
	if (along.gt.180.) along=along-360.0
C
	if ((along.ge.clon).and.(along.lt.clon2)) then  ! +++2
	res11=fhdat(j,ilat)
	res12=fhdat(j+1,ilat)
	res21=fhdat(j,ilat+1)
	res22=fhdat(j+1,ilat+1)
	res1=res11+(res12-res11)*(along-clon)
	res2=res21+(res22-res21)*(along-clon)
	res=res1+(res2-res1)*(glat-aglat)
	endif											 ! +++2
	enddo	! end select pair of longs (j) & (j+1)
	exit
	endif											 !   <<<<1
  161 continue		   ! interpolation end
	close(unit=10)
	RETURN
	END