      subroutine subpred45d2(kYR,kMN,kDY)
C...............................................Feb. 2022
C 45d prediction SSN2 F107
C
      dimension IM(12),x(45),y(45),years(45)
      CHARACTER*64 outfile,infiles,infilef            
      CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 AYEAR
	CHARACTER*2 AYR,AMN,ADY,BDY,BMN,SMN(45),SDY(45)
	CHARACTER*48 product
	CHARACTER*30 titl
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
       product='  Product: 45 Day Forecast SSN2 F107 MSA45 Model'
       titl=' __YEAR___MN_DY___SSN2___F107_'
C      title='______________________________'
        outfile='predict45d.txt'
	OPEN(10,file=outfile)
      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
	AYEAR=DD(1:4)
	AYR=AYEAR(3:4)
	AMN=DD(5:6)
	ADY=DD(7:8)
	write(*,29) product
C		
	write(10,29) product
      WRITE(*,*) ' Issued: Year,Month,Day = ',AYEAR,' ',AMN,' ',ADY,' '
	+,'Time = ',TT
      WRITE(10,*) ' Issued: Year,Month,Day = ',AYEAR,' ',AMN,' ',ADY,' '
	+,'Time = ',TT
   28 format(A30)
   29 format(A48)
       read(ADY,*) rdy
	jdy=int(rdy)
	call blet2(jdy,ADY)
      read(AYR,*) ryr
	jyr=int(ryr)
      read(AMN,*) rmn
	jmn=int(rmn)
	jdy_pre=jdy-2
	jmn_pre=jmn
	jyr_pre=jyr
	if (jdy_pre.le.0) then
	jmn_pre=jmn-1
	if (jmn_pre.eq.0) then
	jmn_pre=12
	jyr_pre=jyr-1
	endif
	jdy_pre=IM(jmn_pre)+jdy_pre
	endif
c+      call blet2(jyr_pre,AYR)
C+	call blet2(jmn_pre,AMN)
C+      call blet2(jdy_pre,ADY)
      call blet2(kyr,AYR)
	call blet2(kmn,AMN)
      call blet2(kdy,ADY)
C
	write(*,28) titl
	write(10,28) titl
        infiles='ssnp45YYMMDDw.txt'
	infilef='covp45YYMMDDw.txt'
	infiles(7:8)=AYR
	infiles(9:10)=AMN
	infiles(11:12)=ADY
	infilef=infiles
	infilef(1:3)='cov'
	OPEN(11,file=infiles,action='READ')
	OPEN(12,file=infilef,action='READ')
	do 50 kk=1,45
	READ(11,30,end=51) ryear,kmn,kdy,fi,ssn
	x(kk)=ssn
	READ(12,30,end=52) years(kk),kmn,kdy,fi,cov
	y(kk)=cov
	call blet2(kmn,BMN)
      call blet2(kdy,BDY)
	SMN(kk)=BMN
	SDY(kk)=BDY
   50	continue
   51	close(unit=11)
   52	close(unit=12)
C
	call subpoly45(x,y,p1fc,p2fc,p3fc,rmsec,xavec,yavec)
      call subpoly45(y,x,p1fs,p2fs,p3fs,rmses,yaves,xaves)
C 2nd proxy:
       DO kk=1,45
	xx=x(kk)
	fcov=xx*(p1fc*xx+p2fc)+p3fc  ! Polyval
	  if (fcov.lt.65.) fcov=65.
	yy=y(kk)
	fssn=yy*(p1fs*yy+p2fs)+p3fs  ! Polyval
	  if (fssn.lt.0.) fssn=0.
	write(*,31) years(kk),smn(kk),sdy(kk),fssn,fcov
	write(10,31) years(kk),smn(kk),sdy(kk),fssn,fcov
	ENDDO
     	close(unit=10)
   30	format(1X,F8.3,2(1X,I2),2X,F7.4,1X,F6.2)
   31	format(1X,F8.3,2(1X,A2),2(1X,F6.1))
C
C
C+        pause ' '
	RETURN
C	STOP
	end
C========================================================
      subroutine subpoly45(x,y,p1,p2,p3,rmse,xave,yave)
	dimension x(45),y(45) 
	nut=45  ! 45d indices
C  
	s0=45.
	s1=0.
	s2=0.
	s3=0.
	s4=0.
	syx2=0.
	syx=0.
	sy=0.
      DO N=1,nut
	x1=x(N)
	x2=x1*x1
	x3=x1*x2
	x4=x2*x2
	y1=y(N)
	yx=y1*x1
	yx2=y1*x2
	s1=s1+x1
	s2=s2+x2
	s3=s3+x3
	s4=s4+x4
	syx2=syx2+yx2
	syx=syx+yx
	sy=sy+y1
      ENDDO 
C
      d1=(s0*s3-s1*s2)
      c1=(s0*s4-s2*s2)/d1
      c2=(s0*syx2-sy*s2)/d1
	d2=(s0*s2-s1*s1)
      c3=(s0*s3-s1*s2)/d2
      c4=(s0*syx-sy*s1)/d2

C
C p1=a; p2=b; p3=c
C
C polyfit2 coefficients
	p1=(c2-c4)/(c1-c3)
	p2=c2-p1*c1
	p3=(sy-p1*s2-p2*s1)/s0
C RMSE
      sum=0.
	DO N=1,nut
	del=y(N)-(x(N)*(p1*x(N)+p2)+p3)
	sum=sum+del**2
	ENDDO
	rmse=sqrt(sum/nut)
	xave=s1/45.
      yave=sy/45.
C
	RETURN
	END
C

